;|
*******************************************************************
*                                                                 *
* Wir sind das "Express-Tools 2 German Project"                   *
* Nachfolgend nur noch abgekrzt durch "ET2GP" !                  *
* --------------------------------------------------------------- *
* Die Beteiligten in alphabetischer Reihenfolge:                  *
*                                                                 *
* Vorname, Name         E-Mail-Adresse          Website           *
* --------------------------------------------------------------- *
* Holger Brischke       kontakt@defun.de        www.defun.de      *
* Martin Drese          drese@defun.de          keine Website     *
* Markus Hoffmann       hoffmann@defun.de       keine Website     *
* Marc Scherer          marc.scherer@zvo.com    keine Website     *
* Peter Tropf           info@petertropf.de      keine Website     *
*                                                                 *
* Special Guest (bersetzung der Hilfe-Texte)                     *
* Walter Verburg        walterverburg@web.de    keine Website     *
*                                                                 *
*******************************************************************

***ET2GP-Anpassung*** -> Kommentar
Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
mchtig ist, haben wir diese bersetzung vorgenommen.

nderungen an den Originaltexten sind immer mit einem einleitenden
Kommentar versehen, wobei die Steuerzeichen fr Kommentare je nach
Dateiart variieren:

Eine nderung an einer Lisp-Datei ist folgendermaen markiert:

;;; ***ET2GP-Anpassung*** ...

Bei einem DCL-File dann so:

/// ***ET2GP-Anpassung*** ...

Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
ein "Auskommentieren" deaktiviert.

Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.

Beispiel:
...
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
         ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
         (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
...

Jede angepasste Datei wird mit diesem Header vorneweg versehen, wobei die
nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
natrlich variabel sind.

***ET2GP-Anpassung*** -> Kommentar
;;; Inhalte geprft, keine nderungen vorgenommen
Version 1.0
30.09.2003
Markus Hoffmann
|;
;;
;;  acetauto.lsp - autoloading for Express Tools
;;
;;  Copyright  2000 by Autodesk, Inc.
;;
;;  Your use of this software is governed by the terms and conditions
;;  of the License Agreement you accepted prior to installation of this
;;  software.  Please note that pursuant to the License Agreement for this
;;  software, "[c]opying of this computer program or its documentation
;;  except as permitted by this License is copyright infringement under
;;  the laws of your country.  If you copy this computer program without
;;  permission of Autodesk, you are violating the law."
;;
;;  AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
;;  AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
;;  MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
;;  DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;;  UNINTERRUPTED OR ERROR FREE.
;;
;;  Use, duplication, or disclosure by the U.S. Government is subject to
;;  restrictions set forth in FAR 52.227-19 (Commercial Computer
;;  Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
;;  (Rights in Technical Data and Computer Software), as applicable.
;;  
;;-------------------------------------------------------------------------
;;  DESCRIPTION
;;    Implements autoloading for Express Tool commands. 2001 Version
;;
;;-------------------------------------------------------------------------
;;

(acet-autoload2	'("ctextapp.arx"	(c:arctext)))
(acet-autoload2	'("ctextapp.arx"	(c:atext)))
(acet-autoload2	'("dimsio.arx"	(c:dimsio)))
(acet-autoload2	'("dimsio.arx"	(c:dimim)))
(acet-autoload2	'("dimsio.arx"	(c:dimex)))
(acet-autoload2	'("fscreen.arx"	(c:fscreen)))
(acet-autoload2	'("laywalk.arx"	(c:laywalk)))
(acet-autoload2	'("leaderex.arx"	(c:qlattach)))
(acet-autoload2	'("leaderex.arx"	(c:qlattachset)))
(acet-autoload2	'("leaderex.arx"	(c:qldetachset)))
(acet-autoload2	'("leaderex.arx"	(c:txt2mtxt)))
(acet-autoload2	'("mocoro.arx"	(c:mocoro)))
(acet-autoload2	'("propulate.arx"	(c:propulate)))
(acet-autoload2	'("sysvdlg.arx"	(c:sysvdlg)))

(acet-autoload2	'("acadinfo.lsp"	(c:acadinfo)	nil	"acadinfo"))
(acet-autoload2	'("acadinfo.lsp"	(c:addvars2scr)	nil	"addvars2scr"))
(acet-autoload2	'("acadinfo.lsp"	(c:lspdump)	nil	"lspdump"))
(acet-autoload2	'("acadinfo.lsp"	(c:vars2scr)	nil	"vars2scr"))
(acet-autoload2	'("acetDoMnu.fas"	(c:expressmenu)	nil	"expressmenu"))
(acet-autoload2	'("acetDoMnu.fas"	(c:rebuild-express-menu)	nil	"rebuild-express-menu"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYCUR)	nil	"LAYCUR"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYFRZ)	nil	"LAYFRZ"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYISO)	nil	"LAYISO"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYLCK)	nil	"LAYLCK"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYMCH)	nil	"LAYMCH"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYOFF)	nil	"LAYOFF"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYON)	nil	"LAYON"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYTHW)	nil	"LAYTHW"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYULK)	nil	"LAYULK"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYUNISO)	nil	"LAYUNISO"))
(acet-autoload2	'("acetlayr.lsp"	(C:LAYVPI)	nil	"LAYVPI"))
(acet-autoload2	'("acetlayr.lsp"	(c:layvpmode)	nil	"layvpmode"))
(acet-autoload2	'("acettxt.lsp"	(c:tcircle)	nil	"tcircle"))
(acet-autoload2	'("acettxt.lsp"	(c:tcount)	nil	"tcount"))
(acet-autoload2	'("acettxt.lsp"	(c:tjust)	nil	"tjust"))
(acet-autoload2	'("acettxt.lsp"	(c:torient)	nil	"torient"))
(acet-autoload2	'("aceturl.lsp"	(C:CHURLS)	nil	"CHURLS"))
(acet-autoload2	'("aceturl.lsp"	(C:REPURLS)	nil	"REPURLS"))
(acet-autoload2	'("aceturl.lsp"	(c:showurls)	nil	"showurls"))
(acet-autoload2	'("acetutil2.fas"	(acet-acadreactor-id-add e1 na2)))
(acet-autoload2	'("acetutil2.fas"	(acet-angle-equal a b fuz)))
(acet-autoload2	'("acetutil2.fas"	(acet-block-purge bna)))
(acet-autoload2	'("acetutil2.fas"	(acet-bs-strip a)))
(acet-autoload2	'("acetutil2.fas"	(acet-calc-tan a)))
(acet-autoload2	'("acetutil2.fas"	(acet-dcl-list-make a lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-dict-name-list dict)))
(acet-autoload2	'("acetutil2.fas"	(acet-dtor a)))
(acet-autoload2	'("acetutil2.fas"	(acet-explode ss)))
(acet-autoload2	'("acetutil2.fas"	(acet-filename-valid fna)))
(acet-autoload2	'("acetutil2.fas"	(acet-full-dwgname)))
(acet-autoload2	'("acetutil2.fas"	(acet-general-props-get-pairs e1)))
(acet-autoload2	'("acetutil2.fas"	(acet-general-props-set-pairs e1 lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-angle-to-ellipseAngle v e1)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-angle-trans ang frm to)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-arc-3p-d-angle p1 p2 p3)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-arc-bulge cent p1 dang)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-arc-center p1 p2 p3)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-arc-d-angle cent p1 p2)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-intersectwith na na2 flag)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-object-fuz na)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-object-normal-vector na)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-self-intersect lst flag2)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-vertex-list na)))
(acet-autoload2	'("acetutil2.fas"	(acet-geom-zoom-for-select lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-list-assoc-put new lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-list-assoc-remove a e1)))
(acet-autoload2	'("acetutil2.fas"	(acet-list-isort lst ind)))
(acet-autoload2	'("acetutil2.fas"	(acet-list-put-nth a lst n)))
(acet-autoload2	'("acetutil2.fas"	(acet-list-remove-adjacent-dups lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-list-remove-duplicates lst fuz)))
(acet-autoload2	'("acetutil2.fas"	(acet-list-to-ss lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-lwpline-make lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-pline-segment-list e1)))
(acet-autoload2	'("acetutil2.fas"	(acet-pline-segment-list-apply e1 lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-point-flat p1 xv xv2)))
(acet-autoload2	'("acetutil2.fas"	(acet-reg-tree-get keypath key)))
(acet-autoload2	'("acetutil2.fas"	(acet-reg-tree-set keypath lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-rtod a)))
(acet-autoload2	'("acetutil2.fas"	(acet-ss-filter arglst)))
(acet-autoload2	'("acetutil2.fas"	(acet-ss-filter-current-ucs ss printflag)))
(acet-autoload2	'("acetutil2.fas"	(acet-ss-filter-item ss a)))
(acet-autoload2	'("acetutil2.fas"	(acet-ss-filter-validate flt)))
(acet-autoload2	'("acetutil2.fas"	(acet-ss-scale-to-fit-base p1 p2 sf)))
(acet-autoload2	'("acetutil2.fas"	(acet-ss-ssget-filter ss flt)))
(acet-autoload2	'("acetutil2.fas"	(acet-ss-to-list ss)))
(acet-autoload2	'("acetutil2.fas"	(acet-ss-union SSLIST)))
(acet-autoload2	'("acetutil2.fas"	(acet-temp-segment p1 p2 p3 dflag)))
(acet-autoload2	'("acetutil2.fas"	(acet-ucs-capture-viewports)))
(acet-autoload2	'("acetutil2.fas"	(acet-ucs-restore-viewports lst)))
(acet-autoload2	'("acetutil2.fas"	(acet-ucs-set-z z)))
(acet-autoload2	'("acetutil2.fas"	(acet-ucs-to-object na)))
(acet-autoload2	'("acetutil2.fas"	(acet-ui-fence-select)))
(acet-autoload2	'("acetutil2.fas"	(acet-ui-getfile str def ext flag)))
(acet-autoload2	'("acetutil2.fas"	(acet-ui-polygon-select dflag)))
(acet-autoload2	'("acetutil2.fas"	(acet-ui-single-select flt lockOk)))
(acet-autoload2	'("acetutil2.fas"	(acet-viewport-frozen-layer-list na)))
(acet-autoload2	'("acetutil2.fas"	(bns_blink_and_show_object na c)))
(acet-autoload2	'("acetutil2.fas"	(bns_blk_match blkname flt lst flag)))
(acet-autoload2	'("acetutil2.fas"	(bns_tbl_match table filter)))
(acet-autoload2	'("acetutil2.fas"	(bns_tjust ss just)))
(acet-autoload2	'("acetutil2.fas"	(isort lst index)))
(acet-autoload2	'("acetutil3.fas"	(acet-acadreactor-id-remove e1 na2)))
(acet-autoload2	'("acetutil3.fas"	(acet-acadreactor-id-remove-all e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-acadreactor-ids-get e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-acadreactor-id-swap newna oldna reflst)))
(acet-autoload2	'("acetutil3.fas"	(acet-alt-viewport ss na2)))
(acet-autoload2	'("acetutil3.fas"	(acet-block-make-anon ss bna)))
(acet-autoload2	'("acetutil3.fas"	(acet-file-find-font fna)))
(acet-autoload2	'("acetutil3.fas"	(acet-filename-associated-app fna)))
(acet-autoload2	'("acetutil3.fas"	(acet-general-props-get e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-general-props-set ss proplst)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-ellipseAngle-to-angle v e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-ellipse-arc-list e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-ellipse-point-at-angle ang e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-ellipse-to-pline e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-is-arc p1 p2 p3 p4 fuz)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-point-inside p1 lst dst)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-point-scale pnt p1 fact)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-rect-points a b)))
(acet-autoload2	'("acetutil3.fas"	(acet-geom-vector-parallel v1 v2)))
(acet-autoload2	'("acetutil3.fas"	(acet-group-make-anon LST DESC)))
(acet-autoload2	'("acetutil3.fas"	(acet-hatch-loopedge-make e1 lst)))
(acet-autoload2	'("acetutil3.fas"	(acet-hatch-loop-make e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-hatch-loop-make-data-get e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-list-assoc-append new lst)))
(acet-autoload2	'("acetutil3.fas"	(acet-list-remove-nth a lst)))
(acet-autoload2	'("acetutil3.fas"	(acet-pline-is-2d e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-plines-explode ss)))
(acet-autoload2	'("acetutil3.fas"	(acet-plines-explode-width-data-get e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-plines-rebuild plst)))
(acet-autoload2	'("acetutil3.fas"	(acet-plines-rebuild-apply-widths w1 w2 e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-plines-rebuild-set-elevation ss z)))
(acet-autoload2	'("acetutil3.fas"	(acet-re-make e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-ss-convert-ellipses-to-plines ss)))
(acet-autoload2	'("acetutil3.fas"	(acet-ss-redraw ss flag)))
(acet-autoload2	'("acetutil3.fas"	(acet-ss-scale-to-fit ss p1 p2 border)))
(acet-autoload2	'("acetutil3.fas"	(acet-ss-zoom-extents ss)))
(acet-autoload2	'("acetutil3.fas"	(acet-str-env-expand fna)))
(acet-autoload2	'("acetutil3.fas"	(acet-str-is-printable a)))
(acet-autoload2	'("acetutil3.fas"	(acet-str-list-select lst spec)))
(acet-autoload2	'("acetutil3.fas"	(acet-tjust ss a)))
(acet-autoload2	'("acetutil3.fas"	(acet-tjust-group-codes just)))
(acet-autoload2	'("acetutil3.fas"	(acet-tjust-keyword e1)))
(acet-autoload2	'("acetutil3.fas"	(acet-ui-drag p1 msg fun)))
(acet-autoload2	'("acetutil3.fas"	(acet-ui-entsel alst)))
(acet-autoload2	'("acetutil3.fas"	(acet-ui-getcorner p1)))
(acet-autoload2	'("acetutil3.fas"	(acet-ui-get-long-name msg)))
(acet-autoload2	'("acetutil3.fas"	(acet-ui-m-get-names alst)))
(acet-autoload2	'("acetutil3.fas"	(acet-viewport-lock-set na flag)))
(acet-autoload2	'("acetutil3.fas"	(acet-viewport-next-pickable)))
(acet-autoload2	'("acetutil3.fas"	(bns_blktbl_match flt)))
(acet-autoload2	'("acetutil3.fas"	(bns_ss_mod ss flag pr)))
(acet-autoload2	'("acetutil3.fas"	(bns_vp_on_screen na)))
(acet-autoload2	'("acetutil4.fas"	(acet-acad-refresh)))
(acet-autoload2	'("acetutil4.fas"	(acet-appid-delete spec)))
(acet-autoload2	'("acetutil4.fas"	(acet-blink-and-show-object alst)))
(acet-autoload2	'("acetutil4.fas"	(acet-calc-bitlist NUM)))
(acet-autoload2	'("acetutil4.fas"	(acet-editor-reactor-add rlst)))
(acet-autoload2	'("acetutil4.fas"	(acet-file-backup fna)))
(acet-autoload2	'("acetutil4.fas"	(acet-file-backup-delete)))
(acet-autoload2	'("acetutil4.fas"	(acet-file-backup-restore)))
(acet-autoload2	'("acetutil4.fas"	(acet-file-find fna)))
(acet-autoload2	'("acetutil4.fas"	(acet-file-find-image fna)))
(acet-autoload2	'("acetutil4.fas"	(acet-file-find-on-path fna path)))
(acet-autoload2	'("acetutil4.fas"	(acet-filename-supportpath-remove fna)))
(acet-autoload2	'("acetutil4.fas"	(acet-file-open fna flag)))
(acet-autoload2	'("acetutil4.fas"	(acet-geom-object-end-points e1)))
(acet-autoload2	'("acetutil4.fas"	(acet-geom-object-z-axis e1)))
(acet-autoload2	'("acetutil4.fas"	(acet-geom-trans-ucs-to-image lst e1 code)))
(acet-autoload2	'("acetutil4.fas"	(acet-list-group-by-assoc lst)))
(acet-autoload2	'("acetutil4.fas"	(acet-list-is-dotted-pair a)))
(acet-autoload2	'("acetutil4.fas"	(acet-list-split lst item)))
(acet-autoload2	'("acetutil4.fas"	(acet-path-to-list a)))
(acet-autoload2	'("acetutil4.fas"	(acet-pline-make lst)))
(acet-autoload2	'("acetutil4.fas"	(acet-pref-supportpath-list)))
(acet-autoload2	'("acetutil4.fas"	(acet-r12-dxf-convert ss)))
(acet-autoload2	'("acetutil4.fas"	(acet-reactor-exists rlst)))
(acet-autoload2	'("acetutil4.fas"	(acet-reactor-remove r)))
(acet-autoload2	'("acetutil4.fas"	(acet-ss-annotation-filter ss)))
(acet-autoload2	'("acetutil4.fas"	(acet-ss-intersection SS1 SS2)))
(acet-autoload2	'("acetutil4.fas"	(acet-ss-remove SS1 SS2)))
(acet-autoload2	'("acetutil4.fas"	(acet-ss-remove-dups ss fuz ignore)))
(acet-autoload2	'("acetutil4.fas"	(acet-ss-remove-dups-extents-list ss fuz)))
(acet-autoload2	'("acetutil4.fas"	(acet-ss-remove-dups-generalize-ent na fuz gclst)))
(acet-autoload2	'("acetutil4.fas"	(acet-ss-remove-dups-reverse lst)))
(acet-autoload2	'("acetutil4.fas"	(acet-ss-sort ss func)))
(acet-autoload2	'("acetutil4.fas"	(acet-sys-control-down)))
(acet-autoload2	'("acetutil4.fas"	(acet-sys-lmouse-down)))
(acet-autoload2	'("acetutil4.fas"	(acet-sys-shift-down)))
(acet-autoload2	'("acetutil4.fas"	(acet-ucs-set lst)))
(acet-autoload2	'("acetutil4.fas"	(acet-viewport-frozen-layer-list-set na laylst)))
(acet-autoload2	'("acetutil4.fas"	(acet-viewport-vpfreeze ss laylst)))
(acet-autoload2	'("acetutil4.fas"	(acet-wmfin FIL)))
(acet-autoload2	'("acetutil4.fas"	(acet-xdata-get LST)))
(acet-autoload2	'("acetutil4.fas"	(acet-xdata-set LST)))
(acet-autoload2	'("acetutil4.fas"	(acet-xref-cproject-path proj)))
(acet-autoload2	'("acetutil4.fas"	(bns_annotation_ss ss)))
(acet-autoload2	'("acetutil4.fas"	(bns_groups_sel lst)))
(acet-autoload2	'("acetutil4.fas"	(bns_groups_unsel)))
(acet-autoload2	'("acetutil4.fas"	(bns_truncate_2_view a b x y x2 y2)))
(acet-autoload2	'("acetutil4.fas"	(acet-insert-attrib-set na lst bquiet)))
(acet-autoload2	'("acetutil4.fas"	(acet-insert-attrib-get lst)))
(acet-autoload2	'("acetutil4.fas"	(bns_mod_att na lst)))
(acet-autoload2	'("acetutil4.fas"	(bns_get_att lst)))
(acet-autoload2	'("acetutil4.fas"	(acet-insert-attrib-mod na lst bquiet)))
(acet-autoload2	'("ai_utils.lsp"	(ai_abort app msg)))
(acet-autoload2	'("ai_utils.lsp"	(ai_acadapp)))
(acet-autoload2	'("ai_utils.lsp"	(ai_alert msg)))
(acet-autoload2	'("ai_utils.lsp"	(ai_angle value error_msg)))
(acet-autoload2	'("ai_utils.lsp"	(ai_angtos val)))
(acet-autoload2	'("ai_utils.lsp"	(ai_aselect)))
(acet-autoload2	'("ai_utils.lsp"	(ai_aselect1 msg)))
(acet-autoload2	'("ai_utils.lsp"	(ai_autossget1 msg)))
(acet-autoload2	'("ai_utils.lsp"	(ai_beep)))
(acet-autoload2	'("ai_utils.lsp"	(ai_common_state ss_ename)))
(acet-autoload2	'("ai_utils.lsp"	(ai_dcl dcl_file)))
(acet-autoload2	'("ai_utils.lsp"	(ai_entity_locked ename message)))
(acet-autoload2	'("ai_utils.lsp"	(ai_error s)))
(acet-autoload2	'("ai_utils.lsp"	(ai_helpfile)))
(acet-autoload2	'("ai_utils.lsp"	(ai_notrans)))
(acet-autoload2	'("ai_utils.lsp"	(ai_num value error_msg range)))
(acet-autoload2	'("ai_utils.lsp"	(ai_return value)))
(acet-autoload2	'("ai_utils.lsp"	(ai_rtos val)))
(acet-autoload2	'("ai_utils.lsp"	(ai_ssget ss)))
(acet-autoload2	'("ai_utils.lsp"	(ai_sslength ss)))
(acet-autoload2	'("ai_utils.lsp"	(ai_strltrim s)))
(acet-autoload2	'("ai_utils.lsp"	(ai_strrtrim s)))
(acet-autoload2	'("ai_utils.lsp"	(ai_strtrim s)))
(acet-autoload2	'("ai_utils.lsp"	(ai_table table_name bit)))
(acet-autoload2	'("ai_utils.lsp"	(ai_trans)))
(acet-autoload2	'("ai_utils.lsp"	(ai_transd)))
(acet-autoload2	'("ai_utils.lsp"	(ai_undo_off)))
(acet-autoload2	'("ai_utils.lsp"	(ai_undo_on)))
(acet-autoload2	'("ai_utils.lsp"	(ai_undo_pop)))
(acet-autoload2	'("ai_utils.lsp"	(ai_undo_push)))
(acet-autoload2	'("aliasedit.lsp"	(C:ALIASEDIT)	nil	"ALIASEDIT"))
(acet-autoload2	'("aspace.lsp"	(c:alignspace)	nil	"alignspace"))
(acet-autoload2	'("attout.lsp"	(c:attin)	nil	"attin"))
(acet-autoload2	'("attout.lsp"	(c:attout)	nil	"attout"))
(acet-autoload2	'("Blockq.lsp"	(c:block?)	nil	"block?"))
(acet-autoload2	'("blocktoxref.lsp"	(c:blockreplace)	nil	"blockreplace"))
(acet-autoload2	'("blocktoxref.lsp"	(c:-blockreplace)	nil	"blockreplace"))
(acet-autoload2	'("blocktoxref.lsp"	(c:blocktoxref)	nil	"blocktoxref"))
(acet-autoload2	'("blocktoxref.lsp"	(c:-blocktoxref)	nil	"blocktoxref"))
(acet-autoload2	'("Breakl.lsp"	(c:breakline)	nil	"breakline"))
(acet-autoload2	'("bscale.lsp"	(c:bscale)	nil	"bscale"))
(acet-autoload2	'("bscale.lsp"	(c:PSBSCALE)	nil	"PSBSCALE"))
(acet-autoload2	'("Burst.lsp"	(C:BURST)	nil	"BURST"))
(acet-autoload2	'("chspace.lsp"	(c:chspace)	nil	"chspace"))
(acet-autoload2	'("Clipit.lsp"	(c:clipit)	nil	"clipit"))
(acet-autoload2	'("closeall.lsp"	(C:CLOSEALL)	nil	"CLOSEALL"))
(acet-autoload2	'("copym.lsp"	(c:copym)	nil	"copym"))
(acet-autoload2	'("copyto.lsp"	(c:copytolayer)	nil	"copytolayer"))
(acet-autoload2	'("copyto.lsp"	(c:-copytolayer)	nil	"copytolayer"))
(acet-autoload2	'("Count.lsp"	(c:bcount)	nil	"bcount"))
(acet-autoload2	'("dimassoc.lsp"	(c:dimreassoc)	nil	"dimreassoc"))
(acet-autoload2	'("etbug.lsp"	(c:etbug)	nil	"etbug"))
(acet-autoload2	'("exoffset.lsp"	(c:exOffset)	nil	"exOffset"))
(acet-autoload2	'("explan.lsp"	(c:explan)	nil	"explan"))
(acet-autoload2	'("fastsel.lsp"	(c:fastsel)	nil	"fastselect"))
(acet-autoload2	'("fastsel.lsp"	(c:fs)	nil	"fastselect"))
(acet-autoload2	'("fastsel.lsp"	(c:fsmode)	nil	"fastselect"))
(acet-autoload2	'("fscreen.lsp"	(c:fullscreen)	nil	"fullscreen"))
(acet-autoload2	'("Getsel.lsp"	(c:GETSEL)	nil	"GETSEL"))
(acet-autoload2	'("ix_edit.lsp"	(c:imageapp)	nil	"imageapp"))
(acet-autoload2	'("ix_edit.lsp"	(c:imageedit)	nil	"imageedit"))
(acet-autoload2	'("Julian.lsp"	(c:date)	nil	"date"))
(acet-autoload2	'("layoutmerge.lsp"	(c:layoutmerge)	nil	"layoutmerge"))
(acet-autoload2	'("layoutmerge.lsp"	(c:-layoutmerge)	nil	"layoutmerge"))
(acet-autoload2	'("Lman.lsp"	(c:lman)	nil	"lman"))
(acet-autoload2	'("Lman.lsp"	(c:-lman)	nil	"lman"))
(acet-autoload2	'("Lman.lsp"	(c:lmanmode)	nil	"lmanmode"))
(acet-autoload2	'("Lman.lsp"	(c:-lmanmode)	nil	"lmanmode"))
(acet-autoload2	'("lspdata.lsp"	(c:lsp)	nil	"lsp"))
(acet-autoload2	'("lspsurf.lsp"	(C:LSPSURF)	nil	"LSPSURF"))
(acet-autoload2	'("Lydelmrg.lsp"	(C:LAYDEL)	nil	"LAYDEL"))
(acet-autoload2	'("Lydelmrg.lsp"	(C:LAYMRG)	nil	"LAYMRG"))
(acet-autoload2	'("Mkltype.lsp"	(c:mkltype)	nil	"mkltype"))
(acet-autoload2	'("Mkshape.lsp"	(c:mkshape)	nil	"mkshape"))
(acet-autoload2	'("MoveBak.lsp"	(C:MOVEBAK)	nil	"MOVEBAK"))
(acet-autoload2	'("Mstretch.lsp"	(c:mstretch)	nil	"mstretch"))
(acet-autoload2	'("plt2dwg.lsp"	(c:plt2dwg)	nil	"plt2dwg"))
(acet-autoload2	'("qquit.lsp"	(C:QQUIT)	nil	"QQUIT"))
(acet-autoload2	'("Redir.lsp"	(c:redir)	nil	"redir"))
(acet-autoload2	'("Redir.lsp"	(c:redirmode)	nil	"redirmode"))
(acet-autoload2	'("Redir.lsp"	(c:-redirmode)	nil	"redirmode"))
(acet-autoload2	'("revert.lsp"	(C:REVERT)	nil	"REVERT"))
(acet-autoload2	'("Rtext.lsp"	(C:RTEDIT)	nil	"RTEDIT"))
(acet-autoload2	'("Rtext.lsp"	(C:RTEXT)	nil	"RTEXT"))
(acet-autoload2	'("Rtext.lsp"	(C:RTEXTAPP)	nil	"RTEXTAPP"))
(acet-autoload2	'("rtucs.lsp"	(c:rtucs)	nil	"rtucs"))
(acet-autoload2	'("rtucs.lsp"	(c:acetucs-top)))
(acet-autoload2	'("rtucs.lsp"	(c:acetucs-front)))
(acet-autoload2	'("rtucs.lsp"	(c:acetucs-right)))
(acet-autoload2	'("rtucs.lsp"	(c:acetucs-back)))
(acet-autoload2	'("rtucs.lsp"	(c:acetucs-left)))
(acet-autoload2	'("rtucs.lsp"	(c:acetucs-bottom)))
(acet-autoload2	'("saveall.lsp"	(C:SAVEALL)	nil	"SAVEALL"))
(acet-autoload2	'("shp2blk.lsp"	(c:shp2blk)	nil	"shp2blk"))
(acet-autoload2	'("Sprhatch.lsp"	(c:imageoverlap)	nil	"imageoverlap"))
(acet-autoload2	'("Sprhatch.lsp"	(c:Superhatch)	nil	"Superhatch"))
(acet-autoload2	'("Sprhatch.lsp"	(c:tframes)	nil	"tframes"))
(acet-autoload2	'("tblname.lsp"	(acet-dict-filter-match tblname flt)))
(acet-autoload2	'("tblname.lsp"	(acet-is-symbol-table str)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-check-flags tblname flags flt)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-format tblname)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-get alst)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-get-cmd alst)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-get-cmd-list msg lst)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-get-dlg alst)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-get-ename tblname name)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-get-is-valid name tblname flags flt lst)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-get-item-list tblname flags flt)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-get-pickit alst)))
(acet-autoload2	'("tblname.lsp"	(acet-ui-table-name-object-data tblname e1 gcode)))
(acet-autoload2	'("tcase.lsp"	(c:tcase)	nil	"tcase"))
(acet-autoload2	'("tcase.lsp"	(c:-tcase)	nil	"tcase"))
(acet-autoload2	'("tedit.lsp"	(C:TEDIT)	nil	"TEDIT"))
(acet-autoload2	'("Textfit.lsp"	(c:textfit)	nil	"textfit"))
(acet-autoload2	'("Textfit.lsp"	(c:TFHELP)	nil	"TFHELP"))
(acet-autoload2	'("Textmask.lsp"	(c:textmask)	nil	"textmask"))
(acet-autoload2	'("Textmask.lsp"	(c:textunmask)	nil	"textunmask"))
(acet-autoload2	'("trex.lsp"	(c:trex)	nil	"trex"))
(acet-autoload2	'("Trexblk.lsp"	(c:bextend)	nil	"bextend"))
(acet-autoload2	'("Trexblk.lsp"	(c:btrim)	nil	"btrim"))
(acet-autoload2	'("Trexblk.lsp"	(c:ncopy)	nil	"ncopy"))
(acet-autoload2	'("tscale.lsp"	(c:psTscale)	nil	"psTscale"))
(acet-autoload2	'("tscale.lsp"	(c:tscale)	nil	"tscale"))
(acet-autoload2	'("tscale.lsp"	(c:tSpaceInvaders)	nil	"tSpaceInvaders"))
(acet-autoload2	'("Txtexp.lsp"	(c:txtexp)	nil	"txtexp"))
(acet-autoload2	'("vpscale.lsp"	(c:vpscale)	nil	"vpscale"))
(acet-autoload2	'("vpsync.lsp"	(c:vpsync)	nil	"vpsync"))
(acet-autoload2	'("Xdata.lsp"	(c:xdata)	nil	"xdata"))
(acet-autoload2	'("Xdata.lsp"	(C:XDLIST)	nil	"XDLIST"))
(acet-autoload2	'("Xlist.lsp"	(c:xlist)	nil	"xlist"))
(acet-autoload2	'("Xlist.lsp"	(c:-xlist)	nil	"xlist"))
(princ)
