;|
*******************************************************************
*                                                                 *
* Wir sind das "Express-Tools 2 German Project"                   *
* Nachfolgend nur noch abgekrzt durch "ET2GP" !                  *
* --------------------------------------------------------------- *
* Die Beteiligten in alphabetischer Reihenfolge:                  *
*                                                                 *
* Vorname, Name         E-Mail-Adresse          Website           *
* --------------------------------------------------------------- *
* Holger Brischke       kontakt@defun.de        www.defun.de      *
* Martin Drese          drese@defun.de          keine Website     *
* Markus Hoffmann       hoffmann@defun.de       keine Website     *
* Marc Scherer          marc.scherer@zvo.com    keine Website     *
* Peter Tropf           info@petertropf.de      keine Website     *
*                                                                 *
* Special Guest (bersetzung der Hilfe-Texte)                     *
* Walter Verburg        walterverburg@web.de    keine Website     *
*                                                                 *
*******************************************************************

***ET2GP-Anpassung*** -> Kommentar
Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
mchtig ist, haben wir diese bersetzung vorgenommen.

nderungen an den Originaltexten sind immer mit einem einleitenden
Kommentar versehen, wobei die Steuerzeichen fr Kommentare je nach
Dateiart variieren:

Eine nderung an einer Lisp-Datei ist folgendermaen markiert:

;;; ***ET2GP-Anpassung*** ...

Bei einem DCL-File dann so:

/// ***ET2GP-Anpassung*** ...

Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
ein "Auskommentieren" deaktiviert.

Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.

Beispiel:
...
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
         ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
         (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
...

Jede angepasste Datei wird mit diesem Header vorneweg versehen, wobei die
nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
natrlich variabel sind.

***ET2GP-Anpassung*** -> Kommentar
Version 1.0
16.10.2003
Markus Hoffmann
|;
;;
;;;
;;;    BLOCKTOXREF.LSP - Randy Kintzley
;;;
;;;    Copyright  1999 by Autodesk, Inc.
;;;
;;;    Your use of this software is governed by the terms and conditions of the
;;;    License Agreement you accepted prior to installation of this software.
;;;    Please note that pursuant to the License Agreement for this software,
;;;    "[c]opying of this computer program or its documentation except as
;;;    permitted by this License is copyright infringement under the laws of
;;;    your country.  If you copy this computer program without permission of
;;;    Autodesk, you are violating the law."
;;;
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;;;    UNINTERRUPTED OR ERROR FREE.
;;;
;;;    Use, duplication, or disclosure by the U.S. Government is subject to
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
;;;    (Rights in Technical Data and Computer Software), as applicable.
;;;
 
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; block replace - replaces one block insert with another.
(defun c:blocktoxref ()
 (acet-error-init 
  (list (list "cmdecho" 0 "highlight" 0 )
        1
  )
 )
 (acet-blocktoxref-ui)
 (acet-error-restore)
);defun c:blocktoxref
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; command line version
(defun c:-blocktoxref ()
 (acet-error-init 
  (list (list "cmdecho" 0 "highlight" 0 "cmddia" 0 "filedia" 0 )
        1
  )
 )
 (acet-blocktoxref-ui)
 (acet-error-restore)
);defun c:-blocktoxref
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; BlockToXref
;
(defun acet-blocktoxref-ui ( / bna fna n prg )
 (if (not acet:blocktoxref-block)
     (setq acet:blocktoxref-block "")
 );if
 (if (= "" (getvar "refeditname"))
     (setq bna (acet-ui-table-name-get 
;;; ***ET2GP-Anpassung*** -> Abfrage bersetzt...
		 ;_(list "Select a block to be replaced with an xref"
		 ;;bersetzung:
		 (list "Block whlen, der durch ein XRef ersetzt werden soll" 
                  acet:blocktoxref-block
                  "block"
                  2		 ;; dis-allow xrefs
                  nil		 ;; ssget style filter
                  "acet1509.hlp" ;; help file
;;; ***ET2GP-Anpassung*** -> Titel des Dialogfensters ergnzt
                  "blocktoxref - block2xref"  ;; topic
                );list
               )
     );setq then not in refedit mode
;;; ***ET2GP-Anpassung*** -> Ausgabe bersetzt...
   ;_(acet-alert "Command not allowed while REFEDIT is active.")
   ;;bersetzung:
   (acet-alert "Befehl ist nicht erlaubt whrend REFEDIT ausgefhrt wird.")
 );if
 
 ;;default value for next time.
 (if bna
     (setq acet:blocktoxref-block bna)
 )
 
 ;; set up a default xref name
 (if (and bna 
          (not acet:blocktoxref-xref)
     );and
     (setq acet:blocktoxref-xref (strcat bna ".dwg"))
 );if
 (if (and bna
          (setq fna (ACET-FILE-WRITEDIALOG 
;;; ***ET2GP-Anpassung*** -> Abfrage bersetzt...
		      ;_"Select an xref file"
		      ;;bersetzung:
		      "XRef-Datei auswhlen" 
                      acet:blocktoxref-xref
                      "dwg"
                      0
                    )
          );setq
     );and
     (progn
      (setq acet:blocktoxref-xref fna)
      (if (progn 
;;; ***ET2GP-Anpassung*** -> initget und Abfrage bersetzt...
	    ;_(initget "Yes No")
            ;_(/= "No" (getkword "\nPurge unreferenced items when finished? <Y>: "))
	    ;;bersetzung:
	    (initget "Ja Nein _Yes No")
;;;           (/= "No" (getkword "\nUnreferenzierte Elemente bereinigen wenn fertig? <J>: "))
;;;           gendert von Peter Tropf:
           (/= "No" (getkword "\nUnreferenzierte Elemente am Ende bereinigen? <J>: "))
          )
          (setq prg T)
      );if
      (setq n (acet-block-to-xref bna fna prg))
;;; ***ET2GP-Anpassung*** -> Ausgaben bersetzt...
      ;_(princ (acet-str-format "\n%1 block inserts replaced with xref: %2" n fna))
      ;_(if (> n 0)
      ;_    (princ "\nResults may not be apparent until next regen.")
      ;_);if
      ;;bersetzung:
      (princ (acet-str-format "\n%1 Blockeinfgungen durch dieses XRef ersetzt: %2" n fna))
      (if (> n 0)
;;;          (princ "\nErgebnis ist mglicherweise erst nach nchstem REGEN sichtbar.")
;;;           gendert von Peter Tropf (damit niemand auf REGEN oder Schnee wartet):
          (princ "\nWenn kein Ergebnis sichtbar ist, RG fr eine Regenerierung eingeben.")
      );if
     );progn then
 );if
);defun acet-blocktoxref-ui
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; block replace - replaces one block insert with another.
(defun c:blockreplace ()
 (acet-error-init
  (list (list "cmdecho" 0 "highlight" 0 )
        1
  )
 )
 (acet-blockreplace-ui)
 (acet-error-restore)
);defun c:blockreplace
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; command line version
(defun c:-blockreplace ()
 (acet-error-init 
  (list (list "cmdecho" 0 "highlight" 0 "cmddia" 0 )
        1
  )
 )
 (acet-blockreplace-ui)
 (acet-error-restore)
);defun c:-blockreplace
 
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
(defun acet-blockreplace-ui ( / bna bna2 n lk prg lst flag bnames  )
 (if (not acet:blockreplace-blocksearch)
     (setq acet:blockreplace-blocksearch "")
 );if
 (if (= "" (getvar "refeditname"))
     (setq bna (acet-ui-table-name-get
;;; ***ET2GP-Anpassung*** -> Abfrage bersetzt...
		 ;_(list "Select the block to be replaced"
		 ;;bersetzung:
		 (list "Block whlen, der ersetzt werden soll" 
                  acet:blockreplace-block
                  "block"
                  2		 ;; dis-allow xrefs
                  nil		 ;; ssget style filter
                  "acet1509.hlp" ;; help file
;;; ***ET2GP-Anpassung*** -> Titel des Dialogfensters ergnzt
                  "blockreplace - blocktausch"  ;; topic
                );list
               )
     );setq
;;; ***ET2GP-Anpassung*** -> Ausgabe bersetzt...
   ;_(acet-alert "Command not allowed while REFEDIT is active.")
   ;;bersetzung:
   (acet-alert "Befehl ist nicht erlaubt whrend REFEDIT ausgefhrt wird.")
 );if
 (if bna
     (setq acet:blockreplace-blocksearch bna)
 );if
 (if (not acet:blockreplace-blockreplace)
     (setq acet:blockreplace-blockreplace "")
 )
 (while (and (not flag)
             bna
             (setq bna2 (acet-ui-table-name-get
;;; ***ET2GP-Anpassung*** -> Abfrage bersetzt...
			  ;_(list (acet-str-format "Select a block to replace %1" bna)
			  ;;bersetzung:
			  (list (acet-str-format "Block whlen zum Ersetzen von %1" bna)
                             acet:blockreplace-blockreplace
                             "block"
                             2			;; dis-allow xrefs
                             nil		;; ssget style filter
                             "acet1509.hlp"	;; help file
;;; ***ET2GP-Anpassung*** -> Titel des Dialogfensters ergnzt
                             "blockreplace - blocktausch" 	;; topic
                         );list
                        )
            );setq
        );and
   (cond
    ((acet-str-equal bna bna2)
;;; ***ET2GP-Anpassung*** -> Ausgabe bersetzt...
     ;_(acet-alert "Invalid. Block names cannot be equal.")
     ;;bersetzung:
     (acet-alert "Ungltig. Blocknamen drfen nicht gleich sein.")
    )
    ;;Cannot replace bna with a block that references bna
    ((and (setq lst (acet-block-referenced-tables bna2 nil))
          (setq bnames (cdr (assoc 2 lst)))
          (member (xstrcase bna) (mapcar 'xstrcase bnames))
     );and
;;; ***ET2GP-Anpassung*** -> Ausgabe bersetzt...
     ;_(acet-alert (acet-str-format "Invalid. Circular reference. %1 references %2." bna2 bna))
     ;;bersetzung:
     (acet-alert (acet-str-format "Ungltig. Zirkulre Referenz. %1 referenziert %2." bna2 bna))
    )
    (T
     (setq flag T)
    )
   );cond close
 );while
 
 (if (and bna bna2);and
     (progn
      (setq acet:blockreplace-blockreplace bna2)
      (if (progn 
;;; ***ET2GP-Anpassung*** -> initget und Abfrage bersetzt...
	    ;_(initget "Yes No")
            ;_(/= "No" (getkword "\nPurge unreferenced items when finished? <Y>: "))
	    ;;bersetzung:
	    (initget "Ja Nein _Yes No")
;;;           (/= "No" (getkword "\nUnreferenzierte Elemente bereinigen wenn fertig? <J>: "))
;;;           gendert von Peter Tropf:
           (/= "No" (getkword "\nUnreferenzierte Elemente am Ende bereinigen? <J>: "))
          )
          (setq prg T)
      );if
      (setq lk (acet-layer-unlock-all))
      (if prg
          (setq lst (acet-block-referenced-tables bna nil))
      );if
      (setq n (acet-block-replace bna bna2))
      (if lk
          (command "_.-layer" "_lock" lk "")
      );if
      (if prg
          (acet-block-referenced-tables-purge lst)
      );if
;;; ***ET2GP-Anpassung*** -> Ausgabe bersetzt...
      ;_(princ (acet-str-format "\n%1 blocks replaced." n))
      ;;bersetzung:
      (princ (acet-str-format "\n%1 Blcke wurden ersetzt." n))
      (if (> n 0)
;;; ***ET2GP-Anpassung*** -> Ausgabe bersetzt...
	;_(princ "\nResults may not be apparent until next regen.")
	;;bersetzung:
;;;	(princ "\nErgebnis ist mglicherweise erst nach nchstem REGEN sichtbar.")
;;;      gendert von Peter Tropf (damit niemand auf REGEN oder Schnee wartet):
        (princ "\nWenn kein Ergebnis sichtbar ist, RG fr eine Regenerierung eingeben.")
      );if
     );progn then
 );if
);defun acet-blockreplace-ui


(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-block-referenced-tables bna tblst)))
(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-block-referenced-tables-ent e1 tblst)))
(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-block-referenced-tables-purge tblst)))
(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-block-replace bna bna2)))
(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-block-to-xref bna fna prg)))
(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-blocktoxref-apply-xref-layer-props lalst origlays laymap)))
(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-blocktoxref-copy-layer-props la la2)))
(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-blocktoxref-local-layer-name xla loclst)))
(acet-autoload2	'("BLOCKTOXREFSUP.LSP"	(acet-blocktoxref-local-to-xref-layer-map xrefname)))
(princ)
