;|
*******************************************************************
*                                                                 *
* Wir sind das "Express-Tools 2 German Project"                   *
* Nachfolgend nur nach abgekrzt durch "ET2GP" !                  *
* --------------------------------------------------------------- *
* Die Beteiligten in alphabetischer Reihenfolge:                  *
*                                                                 *
* Vorname, Name         E-Mail-Adresse          Website           *
* --------------------------------------------------------------- *
* Holger Brischke       kontakt@defun.de        www.defun.de      *
* Martin Drese          drese@defun.de          keine Website     *
* Markus Hoffmann       hoffmann@defun.de       keine Website     *
* Marc Scherer          marc.scherer@zvo.com    keine Website     *
* Peter Tropf           info@petertropf.de      keine Website     *
*                                                                 *
* Special Guest (bersetzung der Hilfe-Texte)                     *
* Walter Verburg        walterverburg@web.de    keine Website     *
*                                                                 *
*******************************************************************

***ET2GP-Anpassung*** -> Kommentar
Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
mchtig ist, haben wir diese bersetzung vorgenommen.

nderungen an den Originaltexten sind immer mit einem einleitenden
Kommentar versehen, wobei die Steuerzeichen fr Kommentare je nach
Dateiart variieren:

Eine nderung an einer Lisp-Datei ist folgendermaen markiert:

;;; ***ET2GP-Anpassung*** ...

Bei einem DCL-File dann so:

/// ***ET2GP-Anpassung*** ...

Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
ein "Auskommentieren" deaktiviert.

Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.

Beispiel:
...
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
         ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
         (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
...

Jede angepasste Datei wird mit diesem Header vorneweg versehen, wobei die
nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
natrlich variabel sind.

***ET2GP-Anpassung*** -> Kommentar
Version 1.0
12.11.2003
Marc Scherer
|;

;;;     COPYTO.LSP
;;;
;;;     Created 1/21/98 by Randy Kintzley
;;;
;;;     Copyright  1998 by Autodesk, Inc.
;;;
;;;     Permission to use, copy, modify, and distribute this software
;;;     for any purpose is restricted by the terms and conditions of
;;;     the AutoCAD Express Tools Software License Agreement.
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; COPYTOLAYER  Copies a selection set to specified layer leaving original
;	    selection set in tact. New entities will reside on user specified 
;           layer. An optional base point prompt follows specifying a layer name.
;           This can be exited by pressing return, or you can pick a base point 
;           and a second base point to place the new objects in the desired location.
;
(defun c:copytolayer ( / )
 (acet-copytolayer-main (getvar "cmddia")) 
);defun c:copytolayer
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:-copytolayer ( / )
 (acet-copytolayer-main 0)
);defun c:-copytolayer
 
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;if the cmddia flag is 1 then the dialog will be invoked.
;if the cmddia=0 then use the command line.
(defun acet-copytolayer-main ( cmddia / ss la p1 lk )
 
 (acet-error-init
  (list (list   "cmdecho" 0
              "highlight" nil
               "limcheck" 0
                 "cmddia" cmddia
        );list
        T      ;use undo
  );list
 );acet-error-init
 
(if (and (setq ss (ssget))
         (setq ss (car (acet-ss-filter
                         (list
                           ss			;selection set
                           '(("LAYERUNLOCKED")) ;remove object on locked layers
                           T                    ;print why 
                         );list
                       )
                  )
         );setq
    );and
    (progn
     (if (or (not acet:copytolayer)
             (not (tblobjname "layer" acet:copytolayer))
         );or
         (setq acet:copytolayer "0")
     );if
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;     (setq la (acet-ui-table-name-get 
;;;                 (list "Specify the destination layer name" 
;;;                       acet:copytolayer
;;;                       "layer"
;;;                       3                         ;;;bit sum  1=allow new and... 2=disable xref dependant
;;;                       nil
;;;                       "acet1503.hlp"
;;;                       "copytolayer"
;;;                 );list
;;;              );acet-ui-table-name-get
;;;     );setq
;;; ***ET2GP-Anpassung*** -> bergabe der Parameter an das Dialogfenster (tblname.lsp/tblname.dcl)
     (setq la (acet-ui-table-name-get
                 (list "Geben Sie den Namen des Ziellayers an" 
                       acet:copytolayer
                       "layer"
                       3                         ;;;bit sum  1=allow new and... 2=disable xref dependant
                       nil
                       "acet1503.hlp"
                       "copytolayer - layerkop"
                 );list
              );acet-ui-table-name-get
     )
     (if la
         (progn
           (setq ss (acet-copytolayer ss la))
           (if (setq lk (acet-layer-locked la))
               (command "_.-layer" "_un" la "")
           ) 
           (setvar "highlight" 1)
           (acet-safe-command T nil (list "_.select" ss))
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;           (if (setq p1 (getpoint "\nBase point or <return> to finish: "))
   	   (if (setq p1 (getpoint "\nBasispunkt eingeben oder <Return> zum Beenden: "))
               (progn
                (acet-safe-command nil T '("")) ;end the select command
                (acet-safe-command T nil (list "_.move" ss ""))
                (setvar "cmdecho" 1)
                (princ "\n")
                (command p1) 
                (while (wcmatch (getvar "cmdnames") "*MOVE*")
                 (command pause)
                );while
               );progn then
               (acet-safe-command nil T '(""));end the select command
           );if
           (acet-cmd-exit) ;and any active command.
           (if lk
               (command "_.-layer" "_lock" la "")
           )
           (setq acet:copytolayer la)
         );progn then
     );if
    );progn then
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;    (princ "\nNothing valid selected.")
    (princ "\nNichts gltiges gewhlt.")
);if
 
(acet-error-restore)
);defun acet-copytolayer-main
 
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun acet-copytolayer ( ss la / na )
 
 (if ss
     (progn
      (if (not (tblobjname "layer" la))
          (acet-layer-copy (getvar "clayer") la)
      );if
 
      (setq na (entlast));setq
      (command "_.copy" ss "" "0,0" "0,0")
      (if (and (setq ss (acet-ss-new na));setq
               (> (sslength ss) 0)
          );and
          (progn
           (command "_.chprop" ss "" "_la" la "");command
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;           (princ (strcat "\n" (itoa (sslength ss)) 
;;;                          " objects copied and placed on layer \""
;;;                          (xstrcase la) "\"."
;;;                  );strcat 
;;;           );princ
	   (princ (strcat "\n" (itoa (sslength ss)) 
                          " Objekte kopiert und auf dem Layer \""
                          (xstrcase la) "\" abgelegt."
                  );strcat 
           )
          );progn then
      );if
     );progn then
 );if
 ss
);defun acet-copytolayer
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;acet-layer-copy - creates a new layer.
;takes two layer names source and target.
(defun acet-layer-copy ( la la2 / na e1)
 
 (setq na (tblobjname "layer" la)
       e1 (entget na '("*"))
       e1 (subst (cons 2 la2) (assoc 2 e1) e1)
 );setq
 (entmake e1)
 
);defun acet-layer-copy


(princ)
