;|
*******************************************************************
*                                                                 *
* Wir sind das "Express-Tools 2 German Project"                   *
* Nachfolgend nur nach abgekrzt durch "ET2GP" !                  *
* --------------------------------------------------------------- *
* Die Beteiligten in alphabetischer Reihenfolge:                  *
*                                                                 *
* Vorname, Name         E-Mail-Adresse          Website           *
* --------------------------------------------------------------- *
* Holger Brischke       kontakt@defun.de        www.defun.de      *
* Martin Drese          drese@defun.de          keine Website     *
* Markus Hoffmann       hoffmann@defun.de       keine Website     *
* Marc Scherer          marc.scherer@zvo.com    keine Website     *
* Peter Tropf           info@petertropf.de      keine Website     *
*                                                                 *
* Special Guest (bersetzung der Hilfe-Texte)                     *
* Walter Verburg        walterverburg@web.de    keine Website     *
*                                                                 *
*******************************************************************

***ET2GP-Anpassung*** -> Kommentar
Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
mchtig ist, haben wir diese bersetzung vorgenommen.

nderungen an den Originaltexten sind immer mit einem einleitenden
Kommentar versehen, wobei die Steuerzeichen fr Kommentare je nach
Dateiart variieren:

Eine nderung an einer Lisp-Datei ist folgendermaen markiert:

;;; ***ET2GP-Anpassung*** ...

Bei einem DCL-File dann so:

/// ***ET2GP-Anpassung*** ...

Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
ein "Auskommentieren" deaktiviert.

Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.

Beispiel:
...
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
         ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
         (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
...

Jede angepasste Datei wird mit diesem Header vorneweg versehen, wobei die
nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
natrlich variabel sind.

***ET2GP-Anpassung*** -> Kommentar
Version 1.0
02.08.2003
Martin Drese
|;
 ;;
;;;
;;;    GATTE.LSP
;;;    Copyright  1999 by Autodesk, Inc.
;;;
;;;    Your use of this software is governed by the terms and conditions of the
;;;    License Agreement you accepted prior to installation of this software.
;;;    Please note that pursuant to the License Agreement for this software,
;;;    "[c]opying of this computer program or its documentation except as
;;;    permitted by this License is copyright infringement under the laws of
;;;    your country.  If you copy this computer program without permission of
;;;    Autodesk, you are violating the law."
;;;
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;;;    UNINTERRUPTED OR ERROR FREE.
;;;
;;;    Use, duplication, or disclosure by the U.S. Government is subject to
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
;;;    (Rights in Technical Data and Computer Software), as applicable.
;;;
;;;  ----------------------------------------------------------------
 
(Defun C:gatte ( /
     N      ;selection set counter
     CC     ;changed counter
     BN     ;block name
     TG     ;tag name
     ESel   ;entity pick/name/list
     EL     ;entity list
     EN     ;entity name
     PASS   ;loop pass flag
     TAGL   ;list of valid tags for a block
     TAGS   ;String of valid tags for a block
     TAGT   ;Temp tag list
     ;TAG    ;tag name in loop
     TMP    ;temporary variable
     SS1    ;selection set of insert objects
     XX X   ;flag and counter
     OLDCC  ;previous count of changes for update test
     A      ;entity information in change loop
     FL LA  ;frozen layer check variables
     na b
     )
 
   (acet-error-init
      (List
         (List "cmdecho" 0)
         T     ;flag. True means use undo for error clean up.
      ) ;list
   );acet-error-init
   (sssetfirst nil nil)
   ;;
   (Setq n 0
         cc 0
   )
   (while (null Pass)
      (initget "Block _Block")
;;      (setq ESel (entsel "\nBlock name/<select block or attribute>: "))
;;;     ***ET2GP-Anpassung*** -> Kommentar
;;;      (setq ESel (entsel "\nSelect block or attribute [Block name]: "))
     (setq ESel (entsel "\nBlock oder Attribut whlen [Block name]: "))
      (cond
        ((null ESel) (setq Pass 'T BN nil))
        ((= (type ESel) 'LIST) ;;pick selection
           (setq EL (entget (car ESel)))
           (if (= (cdr (assoc 0 EL)) "INSERT")
               (setq BN (cdr (assoc 2 EL))
                     Pass 'T
                     ESel (nentselp (cadr ESel))
                     EL (entget (car Esel))
                     TG (if (= (cdr (assoc 0 EL)) "ATTRIB")
                            (cdr (assoc 2 EL))
                            nil
                        )
               )
;;;             ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;               (prompt "\nSelected item not an INSERT.")
;;;               (prompt "\nAuswahl ist kein INSERT.") ; gendert von Peter Tropf:
              (prompt "\n*** Kein Block gewhlt! ***")
           );end if
        );end second conditional for picking attrib
        ((and (= (type ESel) 'STR) (= ESel "Block"))
;;;         ***ET2GP-Anpassung*** -> Kommentar
;;;           (setq BN (getstring "\nEnter block name: "))
         (setq BN (getstring "\nBlocknamen eingeben: "))
           (if (tblsearch "BLOCK" BN)
              (setq Pass 'T)
;;;             ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;              (prompt "\nInvalid block name.")
;;;             (prompt "\nFalscher Blockname.") ; gendert von Peter Tropf:
             (prompt "\n*** Ungltiger Blockname! ***")
           )
        );end third conditional
      );the conditional statement ends
   ) ;;end of Block Name entry.
 
   (if BN (progn
     (setq Pass nil
           EN (cdr (assoc -2 (tblsearch "BLOCK" BN)))
     )
     (while EN
        (setq EL (entget EN))
        (if (= (cdr (assoc 0 EL)) "ATTDEF")
           (setq TAGL (cons (cdr (assoc 2 EL)) TAGL)))
        (setq EN (entnext EN))
     )
   )) ;;end if BN progn
   (if TG (setq Pass 'T))
 
   (if TAGL
     (progn
       (setq TAGS (car TAGL)
             TAGT (cdr TAGL)
       )
       (foreach TAG TAGT
         (setq TAGS (strcat TAGS " " TAG))
       )
     )
   )
;; ***ET2GP-Anpassung*** -> Bug-Bereinigung...
;; Wenn die Attributnamen "_" enthalten, wird das falsch von Acad interpretiert
;; ("_" bedeutet in initget: Hier kommen englische Befehlsoptionen...
;; Lsung: Austausch der "_" durch einen Unique-String: "**" der dann nachher wieder in
;; "_" gendert wird...
  (if TAGL
    (progn
      (setq TAGL (ET2GP-CHANGE-KW TAGL "**" "_")
            TAGS (vl-string-right-trim
                   " "
                   (apply 'strcat
                          (mapcar '(lambda (X) (strcat X " ")) TAGL)
                   ) ;_ end of apply
                 ) ;_ end of vl-string-right-trim
      ) ;_ end of setq
    ) ;_ end of progn
  ) ;_ end of if

  
  (while (and TAGS (null Pass))
      (initget TAGS)
;;;     ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;      (prompt (strcat "\nKnown tag names for block: " TAGS))
;;;     (prompt (strcat "\nBekannte Blocknamen: " TAGS)) ; gendert von Peter Tropf:
    (prompt (strcat "\nVorhandene Attributbezeichnungen: " TAGS))
;;;     ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;      (setq ESel (nentsel "\nSelect attribute or type attribute name: "))
;;;     (setq ESel (nentsel "\nAttribut whlen oder Attributsnamen eingeben: ")) ; gendert von Peter Tropf:    
;;;      (setq ESel (nentsel "\nAttribut whlen oder Attributbezeichnung eingeben: "))
    ;;     ***ET2GP-Anpassung*** -> Erweiterung fr Rechtsklickmen...-> Marc Scherer
    (if (vl-string-search " " TAGS)
      (setq ET2GP-QUEST (while (vl-string-search " " TAGS)
                          (setq TAGS (vl-string-subst "/" " " TAGS))
                        ) ;_ end of while
            ET2GP-QUEST (strcat "[" ET2GP-QUEST "]")
      ) ;_ end of setq
      (setq ET2GP-QUEST (strcat "[" TAGS "]"))
    ) ;_ end of if
    (setq ESel (nentsel (strcat "\nAttribut whlen oder Attributbezeichnung eingeben " ET2GP-QUEST " : ")))
    
      (cond
        ((= (type ESel) 'STR)
           (setq ESel (xstrcase ESel))
           (if (member ESel TAGL)
             (setq PASS 't
                   TG   ESEL
                   ;; ***ET2GP-Anpassung*** -> Handling fr Underscores in Attributnamen...
                   TG   (car (ET2GP-CHANGE-KW (list TG) "_" "**"))
             ) ;_ end of setq
;;;             ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;             (prompt "\nInvalid attribute name.")
;;;             (prompt "\nFalscher Attributsname.") ; gendert von Peter Tropf:
;;;	      Das Programm kommt bei einer falschen Eingabe allerdings nicht an diese Stelle!
             (prompt "\n*** Ungltige Attributbezeichnung! ***")
           ); end if
        )
        ((= (type ESel) 'LIST) ;;pick selection
           (setq TG (cdr (assoc 2 (entget (car ESel)))))
           (if TG
             (setq Pass 'T)
           )
        )
      );the conditional statement ends
   ) ;;end of Attribute Name entry.
 
 
   (if (and BN (null TAGL))
;;;     ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;      (setq BN (prompt "\nThe block selected has no attributes!"))
     (setq BN (prompt "\n*** Der gewhlte Block hat keine Attribute! ***")))
   (if (and BN TG)
      (Progn
;;;        ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;         (prompt (acet-str-format "\nBlock: %1   Attribute tag: %2" BN TG))
        (prompt (acet-str-format "\nBlock: %1   Attributbezeichnung: %2" BN TG))
         (Setq
;;;           ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;            NA (GetString T "\nEnter new text: ")
            NA (GetString T "\nNeuen Text eingeben: ")
            SS1 (SsGet "_X"
                 (List
                    (Cons 0 "INSERT")
                    (Cons 2 bn)
                    (Cons 66 1)
                 )
              )
            N (If SS1 (SsLength SS1) 0)
         )
;;;        ***ET2GP-Anpassung*** -> initget bersetzt...
;;;         (initget 0 "Yes No _Yes No")
        (initget 0 "Ja Nein _Yes No")
         (setq TMP
           (getkword
;;;             ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;             (acet-str-format "\nNumber of inserts in drawing = %1  Process all of them? [Yes/No] <Yes>: " (itoa N))
;;;             (acet-str-format "\nAnzahl der Inserts in Zeichnung = %1  Alle bearbeiten? [Ja/Nein] <Ja>: " (itoa N))))
;;;           gendert von Peter Tropf:
             (acet-str-format "\nAnzahl der Blockeinfgungen = %1  Alle bearbeiten? [Ja/Nein] <Ja>: " (itoa N))))
         (if (and TMP (= TMP "No"))
            (setq SS1 (ssget (list (cons 0 "INSERT")
                                   (cons 2 BN)
                                   (cons 66 1)))
                  N (if SS1 (sslength SS1) 0)
            )
         )
;;;        ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;         (if (> N 0) (Princ "\nPlease wait..."))
        (if (> N 0) (Princ "\nBitte warten..."))
         (setq x 0)
         (repeat N
            (setq A (ssname SS1 x)
                  B (entget A)
                  la (cdr (assoc 8 B))      ;layer name from object
                  fl (tblsearch "LAYER" la) ;table entry for layer
                  fl (cdr (assoc 70 fl))    ;layer status flag
            )
            (if (/= fl 65) ;if layer not frozen
               (progn
                  (setq XX 1
                        oldcc cc)
                  (while XX
                     (setq
                        B (EntGet (EntNext (CDR (Assoc -1 B))))
                     )
                     (If (= (CDR (Assoc 0 B)) "SEQEND")
                        (Setq xx Nil)
                        (Progn
                           (If (= (CDR (Assoc 2 b)) tg)
                              (Progn
                                 (Setq B (subst (Cons 1 NA) (assoc 1 B) B)
                                       CC (1+ CC)
                                 )
                                 (EntMod B)
                              ) ;progn
                           ) ;if
                        ) ;progn
                     ) ;if
                  ) ;while
                  (If (/= cc oldcc) (EntUpd a))
               ) ;progn
            ) ;if
            (Setq X (1+ X))
         ) ;repeat
         (If (/= 1 cc)
;;;           ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;           (princ (acet-str-format "\n%1 attributes changed." (itoa cc)))
;;;           (princ (acet-str-format "\n%1 attribute changed." (itoa cc)))
           (princ (acet-str-format "\n%1 Attribute gendert." (itoa cc)))
           (princ (acet-str-format "\n%1 Attribut gendert." (itoa cc)))
         )
      ) ;progn
   )
   (acet-error-restore)
   (Princ)
) ;defun


(princ)