;|
*******************************************************************
*                                                                 *
* Wir sind das "Express-Tools 2 German Project"                   *
* Nachfolgend nur nach abgekrzt durch "ET2GP" !                  *
* --------------------------------------------------------------- *
* Die Beteiligten in alphabetischer Reihenfolge:                  *
*                                                                 *
* Vorname, Name         E-Mail-Adresse          Website           *
* --------------------------------------------------------------- *
* Holger Brischke       kontakt@defun.de        www.defun.de      *
* Martin Drese          drese@defun.de          keine Website     *
* Markus Hoffmann       hoffmann@defun.de       keine Website     *
* Marc Scherer          marc.scherer@zvo.com    keine Website     *
* Peter Tropf           info@petertropf.de      keine Website     *
*                                                                 *
* Special Guest (bersetzung der Hilfe-Texte)                     *
* Walter Verburg        walterverburg@web.de    keine Website     *
*                                                                 *
*******************************************************************

***ET2GP-Anpassung*** -> Kommentar
Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
mchtig ist, haben wir diese bersetzung vorgenommen.

nderungen an den Originaltexten sind immer mit einem einleitenden
Kommentar versehen, wobei die Steuerzeichen fr Kommentare je nach
Dateiart variieren:

Eine nderung an einer Lisp-Datei ist folgendermaen markiert:

;;; ***ET2GP-Anpassung*** ...

Bei einem DCL-File dann so:

/// ***ET2GP-Anpassung*** ...

Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
ein "Auskommentieren" deaktiviert.

Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.

Beispiel:
...
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
         ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
         (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
...

Jede angepasste Datei wird mit diesem Header vorneweg versehen, wobei die
nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
natrlich variabel sind.

***ET2GP-Anpassung*** -> Kommentar
Version 1.0
02.08.2003
Martin Drese
|;
 
;;
;;;
;;;    GETSEL.LSP
;;;    Copyright  1999 by Autodesk, Inc.
;;;
;;;    Your use of this software is governed by the terms and conditions of the
;;;    License Agreement you accepted prior to installation of this software.
;;;    Please note that pursuant to the License Agreement for this software,
;;;    "[c]opying of this computer program or its documentation except as
;;;    permitted by this License is copyright infringement under the laws of
;;;    your country.  If you copy this computer program without permission of
;;;    Autodesk, you are violating the law."
;;;
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;;;    UNINTERRUPTED OR ERROR FREE.
;;;
;;;    Use, duplication, or disclosure by the U.S. Government is subject to
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
;;;    (Rights in Technical Data and Computer Software), as applicable.
;;;
;;;  ----------------------------------------------------------------
 
(defun c:GETSEL (/ LAY    ;; Layer of the selected entity
                   ENT    ;; Entity type of seleted entity
                   SS     ;; Selection set
                   SSLST  ;; Filter list
                   cspace ;; current space
                )
 
  (acet-error-init
         (list
           (list "cmdecho" 0
                 "expert"  0
           )
           T     ;flag. True means use undo for error clean up.
         )       ;list
  );acet-error-init
  (sssetfirst nil nil)
 
  ;;(setq LAY (car(entsel "\nSelect Object on layer to Select from <*>: ")))
;;;  ***ET2GP-Anpassung*** -> Kommentar
;;;  (setq LAY (car (entsel "\nSelect an object on the Source layer <*>: ")))
;;;  (setq LAY (car (entsel "\nObjekt auf dem Quelllayer whlen <*>: "))) ; gendert von Peter Tropf:
  (setq LAY (car (entsel "\nWhlen Sie ein Objekt des gewnschten Layers <*>: ")))
 
  (if LAY
    (setq LAY  (cdr(assoc 8 (entget LAY)))
          SSLST (list (cons 8 LAY ))
    )
  )
 
  ;;(setq ENT (car(entsel "\nSelect type of entity you want <*>: ")))
;;;  ***ET2GP-Anpassung*** -> Kommentar
;;;  (setq ENT (car(entsel "\nSelect an object of the Type you want <*>: ")))
;;;  (setq ENT (car(entsel "\nWhle ein Objekt als Vorgabe <*>: "))) ; gendert von Peter Tropf:
  (setq ENT (car(entsel "\nWhlen Sie ein Objekt des gewnschten Typs <*>: ")))
 
  (if ENT
    (progn
      (setq ENT  (cdr(assoc 0 (entget ENT))))
      (if SSLST
         (setq SSLST (append (list (cons 0 ENT )) SSLST))
         (setq SSLST (list (cons 0 ENT )))
      )
    )
  )
  (if SSLST
    (progn
      (cond
        ((and LAY ENT)
;;;         ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;          (prompt (acet-str-format "\nCollecting all %1 objects on layer %2..." ENT LAY))
;;;         (prompt (acet-str-format "\nSammle alle %1 Objekte auf Layer %2..." ENT LAY)) 
;;;          gendert von Peter Tropf:
         (prompt (acet-str-format "\nEs werden alle %1-Objekte auf dem Layer %2 gewhlt ..." ENT LAY))
        )
        (LAY
;;;         ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;          (prompt (acet-str-format "\nCollecting ALL objects on layer %1..."  LAY ))
;;;         (prompt (acet-str-format "\nSammle ALLE Objekte des Layers %1..."  LAY ))
;;;          gendert von Peter Tropf:
         (prompt (acet-str-format "\nEs werden ALLE Objekte des Layers %1 gewhlt ..."  LAY ))
        )
        (ENT
;;;         ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;          (prompt (acet-str-format "\nCollecting all %1 objects in the drawing..."  ENT ))
;;;         (prompt (acet-str-format "\nSammle alle %1 Objekte aus der Zeichnung..."  ENT ))
;;;          gendert von Peter Tropf:
         (prompt (acet-str-format "\nEs werden alle %1-Objekte der Zeichnung gewhlt ..."  ENT ))
        )
        (T
;;;         ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;          (prompt "\nCollecting all objects in the drawing...")
;;;         (prompt "\nSammle alle Objekte aus der Zeichnung...")
;;;          gendert von Peter Tropf (allerdings kommt das Programm NIE an diese Stelle):
         (prompt "\nEs werden ALLE Objekte der Zeichnung gewhlt ...")
        )
      ) ;cond
      (setq SS (ssget "_X" SSLST))
    )
    (progn
;;;         ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;         die folgende Zeile wurde von oben hier eingefgt (Bug im Original)
      (prompt "\nEs werden ALLE Objekte der Zeichnung gewhlt ...")
      (setq SS (ssget "_X"))
    ) ;progn
  )
  (if SS
    (progn
      (setq SS (sslength SS))
      (if (> SS 0)
        (if (= SS 1)
          (prompt
;;;            ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;            (acet-str-format "\n%1 object has been placed in the active selection set." (itoa SS))
;;;            (acet-str-format "\n%1 Objekt wurde in den aktuellen Auswahlsatz aufgenommen." (itoa SS))
            ; gendert von Peter Tropf:
            (acet-str-format 
             "\n%1 Objekt ist im aktuellen Auswahlsatz (bei Objekte whlen: V eingeben)." (itoa SS))
          )
          (prompt
;;;            ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;            (acet-str-format "\n%1 objects have been placed in the active selection set." (itoa SS))
;;;            (acet-str-format "\n%1 Objekte wurden in den aktuellen Auswahlsatz aufgenommen." (itoa SS))
            ; gendert von Peter Tropf:
            (acet-str-format 
             "\n%1 Objekte sind im aktuellen Auswahlsatz (bei Objekte whlen: V eingeben)." (itoa SS))
          )
        ) ;if
;;;        ***ET2GP-Anpassung*** -> Dialog bersetzt...
;;;        (prompt"\nNothing selected.")
        (prompt"\nNichts gewhlt.")
      )
    ) ;progn
  ) ;if
 
  (acet-error-restore)
 
  (princ)
 
);end defun


(princ)