;|
*******************************************************************
*                                                                 *
* Wir sind das "Express-Tools 2 German Project"                   *
* Nachfolgend nur nach abgekrzt durch "ET2GP" !                  *
* --------------------------------------------------------------- *
* Die Beteiligten in alphabetischer Reihenfolge:                  *
*                                                                 *
* Vorname, Name         E-Mail-Adresse          Website           *
* --------------------------------------------------------------- *
* Holger Brischke       kontakt@defun.de        www.defun.de      *
* Martin Drese          drese@defun.de          keine Website     *
* Markus Hoffmann       hoffmann@defun.de       keine Website     *
* Marc Scherer          marc.scherer@zvo.com    keine Website     *
* Peter Tropf           info@petertropf.de      keine Website     *
*                                                                 *
* Special Guest (bersetzung der Hilfe-Texte)                     *
* Walter Verburg        walterverburg@web.de    keine Website     *
*                                                                 *
*******************************************************************

***ET2GP-Anpassung*** -> Kommentar
Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
mchtig ist, haben wir diese bersetzung vorgenommen.

nderungen an den Originaltexten sind immer mit einem einleitenden
Kommentar versehen, wobei die Steuerzeichen fr Kommentare je nach
Dateiart variieren:

Eine nderung an einer Lisp-Datei ist folgendermaen markiert:

;;; ***ET2GP-Anpassung*** ...

Bei einem DCL-File dann so:

/// ***ET2GP-Anpassung*** ...

Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
ein "Auskommentieren" deaktiviert.

Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.

Beispiel:
...
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
         ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
         (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
...

Jede angepasste Datei wird mit diesem Header vorneweg versehen, wobei die
nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
natrlich variabel sind.

***ET2GP-Anpassung*** -> Kommentar
Version 1.0
17.10.2003
Marc Scherer

nderungen durch Peter Tropf:
-"mischen" durch "verschieben" ersetzt
-"PERMANENT" durch "ENDGLTIG" ersetzt
-differenzierter Dialog (neue Variablen zahl und string)
|;

;;;
;;;    LYDELMRG.LSP
;;;
;;;    By Dominic Panholzer
;;;
;;;    Copyright  1999 by Autodesk, Inc.
;;;
;;;    Your use of this software is governed by the terms and conditions of the
;;;    License Agreement you accepted prior to installation of this software.
;;;    Please note that pursuant to the License Agreement for this software,
;;;    "[c]opying of this computer program or its documentation except as
;;;    permitted by this License is copyright infringement under the laws of
;;;    your country.  If you copy this computer program without permission of
;;;    Autodesk, you are violating the law."
;;;
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;;;    UNINTERRUPTED OR ERROR FREE.
;;;
;;;    Use, duplication, or disclosure by the U.S. Government is subject to
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
;;;    (Rights in Technical Data and Computer Software), as applicable.
;;;
;;;  ----------------------------------------------------------------
;;;
;;;  External Functions:
;;;
;;;     ACET-ERROR-INIT       --> ACETUTIL.FAS   Intializes bonus error routine
;;;     ACET-ERROR-RESTORE    --> ACETUTIL.FAS   restores old error routine
;;;     ACET-LAYER-LOCKED     --> ACETUTIL.FAS   Checks to see if layer is locked
;;;     ACET-TABLE-NAME-LIST  --> ACETUTIL.FAS   Returns a list of table enties
;;;     ACET-SPINNER          --> ACETUTIL.FAS   Shows spinner while work is being done

;;; -------------------- LAYER DELETE FUNCTION ---------------------
;;; Deletes layer from drawing.
;;; ----------------------------------------------------------------

(defun C:LAYDEL ()
  (if (= (getvar "fullopen") 1)
    (ACET-LYDELMRG-MAIN "delete")
    ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
    ;; (princ "\nLAYDEL cannot be used on partially opened drawings.")
    (princ
      "\nLAYLSCH/LAYDEL kann nicht in partiell geffneten Zeichnungen angewendet werden."
    ) ;_ end princ
  ) ;_ end if
  (princ)
) ;_ end defun C:LAYDEL

;;; --------------------- LAYER MERGE FUNCTION ---------------------
;;; Merges layer with second layer.
;;; ----------------------------------------------------------------

(defun C:LAYMRG ()
  (if (= (getvar "fullopen") 1)
    (ACET-LYDELMRG-MAIN "merge")
    ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
    ;; (princ "\nLAYMRG cannot be used on partially opened drawings.")
    (princ
      "\nLAYMISCH/LAYMRG kann nicht in partiell geffneten Zeichnungen angewendet werden."
    ) ;_ end princ
  ) ;_ end if
  (princ)
) ;_ end defun C:LAYMRG

;;; ------------- LAYER PROCESSOR FOR LAYDEL & LAYMRG --------------
;;;  Main program body for LAYDEL and LAYMRG.
;;;  This function will remove all the entities on a selected layer and
;;;  remove the layer from the drawing. If the merge option is
;;;  selected, all the entities on the layer to be removed will be
;;;  changed to the merging layer. Block definitions referencing the
;;;  layer to be removed will be redefined with the dependencies
;;;  removed (or changed when merging.)
;;; ----------------------------------------------------------------

(defun ACET-LYDELMRG-MAIN (MODE            /
                           ACET-LYDELMRG-BLKREDEF
                           ACET-LYDELMRG-ATTREDEF
                           ACET-LYDELMRG-LAYINBLKLST
                           ACET-LYDELMRG-LAYOUTLIST
                           ACET-LYDELMRG-VPCHECK
                           ANS             LOOP
                           LAYLST          CLAY
                           LAYSTR          LAY
                           VAL             LST
                           BLKLST          STR
                           FLTR            SS
                           CNT             EN
                           PASS            NEWLAY
                           CVPORT          NOPURGE_LST
                           ALERT_STRING    LAYOUTLST
                           CLAYOUT         ZAHL
                           STRING
                          )


;;; --------------------- BLKREDEF FUNCTION ------------------------
;;;   This function redefines block BNAM removing dependencies on
;;;   layers in the list LAYLST. MODE can be either
;;;   "delete" or "merge". If merge is used NEWLAY specifies
;;;   the target layer.
;;; ----------------------------------------------------------------

  (defun ACET-LYDELMRG-BLKREDEF
         (BNAM LAYLST MODE NEWLAY / BLK EN ED ILAY ABLK FLTR)

    (entmake)

    (setq BLK (entget (tblobjname "BLOCK" BNAM) '("*"))
                                        ; Get first block definition
          BLK (subst (cons 8 "0") (assoc 8 BLK) BLK)
                                        ; Make sure the def is on lay 0
          EN  (cdr (assoc -2 BLK))      ; and the first subentity
    ) ;_ end setq

    (entmake BLK)                       ; Start redefining the block
    (while EN                           ; While there are subentities

      (setq ED (entget EN '("*")))
      (if (or
            (= "POLYLINE" (cdr (assoc 0 ED)))
                                        ; If the subent is a polyline
            (and
              (= "INSERT" (cdr (assoc 0 ED)))
                                        ; or if the subent is a block
              (= 1 (cdr (assoc 66 ED))) ; with attributes
            ) ;_ end and
          ) ;_ end or
        (setq ABLK t                    ; then set the complex entity flag
              ILAY (cdr (assoc 8 ED))   ; and save the layer.
        ) ;_ end setq
      ) ;_ end if

      (if (member (cdr (assoc 8 ED)) LAYLST)
                                        ; If its layer is in the list
        (progn
          (if (= (xstrcase MODE) "MERGE")
                                        ; if the layer is to be merged
            (progn
              (setq ED (subst (cons 8 NEWLAY) (assoc 8 ED) ED))
                                        ; substitute the old layer with new
              (entmake ED)              ; and add the entity to the definition
            ) ;_ end progn
            (progn                      ; else if layer is to be deleted
              (if (= "SEQEND" (cdr (assoc 0 ED)))
                                        ; If the ent is a seqend
                (progn                  ; change its layer to that of the insert
                  (setq ED (subst (cons 8 ILAY) (assoc 8 ED) ED))
                  (entmake ED)          ; and add it to the definition.
                ) ;_ end progn
              ) ;_ end if
              (if ABLK                  ; If the complex entity flag is set,
                (while (/= "SEQEND" (cdr (assoc 0 ED)))
                                        ; while the entity is not a seqend,
                  (setq EN (entnext EN) ; step through the sub entities
                        ED (entget EN '("*"))
                                        ; removing them from the definition.
                  ) ;_ end setq
                ) ;_ end while
              ) ;_ end if
            ) ;_ end progn
          ) ;_ end if
        ) ;_ end progn
        (entmake ED)                    ; If layer does not match, add
      )                                 ; the entity to the definition
      (setq EN   (entnext EN)           ; get the next subentity
            ABLK NIL                    ; and reset the attribute block flag.
      ) ;_ end setq
    ) ;_ end while

    (setq BNAM (entmake (list (cons 0 "ENDBLK"))))
                                        ; complete the redefinition

    (if (and (= (xstrcase MODE) "DELETE") ; If in delete mode and
             (not (entnext (tblobjname "BLOCK" BNAM)))
                                        ; the block definition has no entities
        ) ;_ end and
      (progn
        (setq FLTR (list '(-4 . "<AND")
                         '(0 . "INSERT")
                         (cons 2 BNAM)
                         '(-4 . "AND>")
                   ) ;_ end list
        ) ;_ end Setq
        (if (setq SS (ssget "_x" FLTR))
          (command "_.erase" SS "")     ; erase all the insertions
        ) ;_ end if
        (if (setq SS (ssget "_x" FLTR))
          (progn
            (setq CNT 0)
            (while (and SS
                        (> (sslength SS) 0)
                        (setq EN (ssname SS CNT))
                   )                    ;and
              (entdel EN)
              (setq CNT (1+ CNT))
            ) ;_ end while
          ) ;_ end progn
        ) ;_ end if
        (if (tblobjname "BLOCK" BNAM)
          (ACET-TABLE-PURGE "block" BNAM NIL)
        ) ;_ end if
      ) ;_ end progn
    ) ;_ end if
  ) ;_ end defun ACET-LYDELMRG-BLKREDEF

;;; ----------------- ATTRIBUTE REDEF FUNCTION ---------------------
;;;   This function recreates block insertions which have
;;;   attributes which reference layer LAY. MODE can be either
;;;   "delete" or "merge". If merge is used NEWLAY specifies
;;;   the target layer.
;;; ----------------------------------------------------------------

  (defun ACET-LYDELMRG-ATTREDEF
         (LAY MODE NEWLAY / FLTR SS CNT EN ILAY ELST DOIT LAYLCK)
    (setq FLTR (list '(0 . "INSERT") '(66 . 1))
          SS   (ssget "_x" FLTR)
          CNT  0
    ) ;_ end setq
    (while (and SS
                (> (sslength SS) 0)
                (setq EN (ssname SS CNT))
           )                            ;and
      (setq ED   (entget EN '("*"))
            ILAY (cdr (assoc 8 ED))
            ELST (list ED)
            DOIT NIL
      ) ;_ end setq
      (while (/= "SEQEND"
                 (cdr (assoc 0 (entget (setq EN (entnext EN)))))
             ) ;_ end /=
        (setq ED (entget EN '("*")))
        (if (/= LAY (cdr (assoc 8 ED)))
          (setq ELST (cons ED ELST))
          (progn
            (if (= (xstrcase MODE) "MERGE")
              (setq ED   (subst (cons 8 NEWLAY) (assoc 8 ED) ED)
                    ELST (cons ED ELST)
              ) ;_ end setq
            ) ;_ end if
            (setq DOIT t)
          ) ;_ end progn
        ) ;_ end if
      ) ;_ end while

      (setq ELST (reverse ELST)
            ED   (entget EN '("*"))
      ) ;_ end setq

      (if (< 1 (length ELST))
        (if (or DOIT (= LAY (cdr (assoc 8 ED))))
          (progn
            ;;(entmake nil)
            (entmake)
            (foreach MBR ELST (entmake MBR))
            (entmake (subst (cons 8 ILAY) (assoc 8 ED) ED))
            (entdel (cdr (assoc -1 (car ELST))))
          ) ;_ end progn
        ) ;_ end if
        (progn
          ;;(entmake nil)
          (entmake)
          (entmake
            (subst (cons 66 0) (assoc 66 (car ELST)) (car ELST))
          ) ;_ end entmake
          (if
            (setq LAYLCK (ACET-LAYER-LOCKED (cdr (assoc 8 (car ELST)))))
             (command "_.-layer" "_u" (cdr (assoc 8 (car ELST))) "")
          ) ;_ end if
          (entdel (cdr (assoc -1 (car ELST))))
          (if LAYLCK
            (command "_.-layer" "_lo" (cdr (assoc 8 (car ELST))) "")
          ) ;_ end if
        ) ;_ end progn
      ) ;_ end if
      (setq CNT (1+ CNT))
    ) ;_ end while
  ) ;_ end defun ACET-LYDELMRG-ATTREDEF

;;; --------------- GET REFERENCED LAYERS FUNCTION -----------------
;;;  Returns list of blocks which reference Layer LAY
;;; ----------------------------------------------------------------

  (defun ACET-LYDELMRG-LAYINBLKLST (LAY / BLK NAM EN NAMLST)
    ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
    ;; (princ "\nQuerying block table  ")
    (princ "\nAbfragen der Block-Tabelle  ")

    (setq BLK (tblnext "BLOCK" t))      ; Get first block definition
    (while BLK                          ; If there is a block
      (if (= (logand (cdr (assoc 70 BLK)) 32) 0)
                                        ; and it is not xref dependent,
        (progn
          (setq NAM (cdr (assoc 2 BLK)) ; get the name
                EN  (tblobjname "BLOCK" NAM) ; and the first entity
          ) ;_ end setq
          (while EN                     ; while there is a subentity
            (if (= LAY (cdr (assoc 8 (entget EN))))
                                        ; if the ent is on the layer
              (setq NAMLST (if NAMLST   ; add the name to the list
                             (append NAMLST (list NAM))
                             (list NAM)
                           ) ;_ end if
                    EN     NIL          ; and skip other subentities
              ) ;_ end setq
              (setq EN (entnext EN))    ; else get the next subentity
            ) ;_ end if
            (ACET-SPINNER)
          ) ;_ end while
        ) ;_ end progn
      ) ;_ end if
      (setq BLK (tblnext "BLOCK"))      ; get the next block
    ) ;_ end while
    (prompt "\r                      ")
    (if (/= NAMLST "")
      NAMLST                            ; return the list of blocks
    ) ;_ end if
  ) ;_ end defun ACET-LYDELMRG-LAYINBLKLST


;;; -------------------- LAYOUT LIST FUNCTION ----------------------
;;;   Returns list of layouts that have viewports that reference
;;;   the layers in LAYLST via vplayer freeze or by being on the layer.
;;;   If MODE == "Merge" the layout list will include those layouts
;;;   with any entities on the layer to be merged.
;;; ----------------------------------------------------------------

  (defun ACET-LYDELMRG-LAYOUTLIST (LAYLST    MODE      /
                                   SS        LAYOUTS   CNT
                                   VP        XLST      LAYOUTNAME
                                   CLAYOUT   LAYOUTLST ADD
                                   VPFRZ     DEPLAYLST LAYFLTR
                                   LAYOUTFLTR
                                  )

    (setq LAYOUTS    (cons "Model" (layoutlist))
                                        ; Get a list of all the layouts
          LAYOUTS    (vl-remove (getvar "ctab") LAYOUTS)
                                        ; except the current one
          LAYOUTFLTR (mapcar '(lambda (X) (cons 410 X)) LAYOUTS)
                                        ; Make a layout filter list
          LAYOUTFLTR (append '((-4 . "<OR")) LAYOUTFLTR '((-4 . "OR>")))
          CNT        0
    ) ;_ end setq

    (setq SS (ssget "_x"
                    (append '((-4 . "<AND"))
                                        ; Get all the viewports in all layouts
                            '((0 . "VIEWPORT"))
                                        ; except the current one.
                            LAYOUTFLTR
                            '((-4 . "AND>"))
                    ) ;_ end append
             ) ;_ end ssget
    ) ;_ end setq

    (if (and SS (> (sslength SS) 0))    ; if there are any
      (progn
        (while (and
                 LAYOUTS                ; while not all layouts have been used
                 (setq VP (ssname SS CNT)) ; step through each viewport
               ) ;_ end and

          (setq VP         (entget VP '("ACAD"))
                                        ; get the viewport's edata
                LAYOUTNAME (cdr (assoc 410 VP))
                                        ; get the viewport's layout
                XLST       (cdadr (assoc -3 VP)) ; get the xdata list
          ) ;_ end setq

          (if (member (cdr (assoc 8 VP)) LAYLST)
                                        ; if the vp is on the layer
            (setq ADD t                 ; earmark the layout to be added
                  VPFRZ t               ; and increment the vpfrz counter
            ) ;_ end setq
          ) ;_ end if

          (if (not ADD)                 ; If the layout has not been earmarked
            (progn
              (setq DEPLAYLST (ACET-LIST-M-ASSOC 1003 XLST)
                                        ; Find all the dependant layers
                    DEPLAYLST (mapcar 'cdr DEPLAYLST)
                                        ; and get their names
              ) ;_ end setq
              (while DEPLAYLST          ; while the dependant name list exists,
                (if (member (car DEPLAYLST) LAYLST)
                                        ; if the first member is in LAYLST
                  (setq ADD t
                        DEPLAYLST NIL   ; Stop processing this viewport
                  ) ;_ end setq
                  (setq DEPLAYLST (cdr DEPLAYLST))
                                        ; remove the first item of the dependant list
                ) ;_ end if
              ) ;_ end while
            ) ;_ end progn
          ) ;_ end if
          (if (and ADD (not (member LAYOUTNAME LAYOUTLST)))
                                        ; If the layout has not already been added
            (setq LAYOUTLST (cons LAYOUTNAME LAYOUTLST)
                                        ; Add it to the list,
                  LAYOUTS   (vl-remove LAYOUTNAME LAYOUTS)
                                        ; remove it from the master list,
                  ADD       NIL         ; and reset the ADD flag
            ) ;_ end setq
            (setq ADD NIL)              ; otherwise just reset the ADD flag
          ) ;_ end if
          (setq CNT (1+ CNT))
        ) ;_ end while
      ) ;_ end progn
    ) ;_ end if

    (if (= (xstrcase MODE) "DELETE")
      (setq CLAYOUT (vla-get-activedocument (vlax-get-acad-object))
            CLAYOUT (vla-get-name
                      (vla-get-layout (vla-get-paperspace CLAYOUT))
                    ) ;_ end vla-get-name
            LAYOUTS (vl-remove CLAYOUT LAYOUTS)
      ) ;_ end setq
    ) ;_ end if

    (if LAYOUTS
      (progn
        (setq LAYFLTR (mapcar '(lambda (X) (cons 8 X)) LAYLST)
                                        ; Make a layer filter list
              LAYFLTR (append '((-4 . "<OR")) LAYFLTR '((-4 . "OR>")))
        ) ;_ end setq
        (foreach LAYOUT LAYOUTS
          (if (ssget "_x"
                     (append
                       '((-4 . "<AND"))
                       (list (cons 410 LAYOUT))
                       LAYFLTR
                       '((-4 . "AND>"))
                     ) ;_ end append
              ) ;_ end ssget
            (setq LAYOUTLST (cons LAYOUT LAYOUTLST))
                                        ; Add the layout to the list
          ) ;_ end if
        ) ;_ end foreach
      ) ;_ end progn
    ) ;_ end if
    (if LAYOUTLST
      (setq LAYOUTLST (cons VPFRZ LAYOUTLST))
    ) ;_ end if
  ) ;_ end defun ACET-LYDELMRG-LAYOUTLIST


;;; ----------------- VIEWPORT CHECKING FUNCTION -------------------
;;;   This function will check for viewports being referenced by
;;;   any layer in LAYLST. If it finds any it will clear the
;;;   references via VPLAYER. If tilemode is 1 and referenced
;;;   viewports exist, The user is asked permission to switch tilemode.
;;;   Returns T if no viewports exist.
;;;   Returns nil if vp exist but user does not want to switch tilemode.
;;;   Else returns active viewport number.
;;; ----------------------------------------------------------------

  (defun ACET-LYDELMRG-VPCHECK (LAYLST   MODE     /        LAYOUTLST
                                VPON     PASS     CLAYOUT  CVPORT
                               )

    (setq LAYOUTLST (ACET-LYDELMRG-LAYOUTLIST LAYLST MODE))

    (if LAYOUTLST                       ; If layers are being referenced
      (if (= (logand (getvar "cmdactive") 4) 4) ; if a script is active
        (setq PASS "Yes")               ; skip the questions
        (progn
          (setq VPON      (car LAYOUTLST)
                                        ; retrieve the VP on layer flag
                LAYOUTLST (cdr LAYOUTLST)
          ) ;_ end setq
          (cond
            ((< 1 (length LAYOUTLST))   ; More than one layout with vpfreeze referenced layer(s)
             (terpri)
;;;		 ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (prompt (acet-str-format "\nThere are %1 other layouts that reference one or more of the selected layers."  (length LAYOUTLST)))
;;;              (prompt "\nIn order for this command to continue these layouts will need to be set current.")
             (prompt
               (acet-str-format
                 "\nEs gibt %1 weitere Layouts, die mindestens 1 der gewhlten Layer referenzieren."
                 (length LAYOUTLST)
               ) ;_ end acet-str-format
             ) ;_ end prompt
             (prompt
               "\nUm diesen Befehl fortzusetzen, mssen diese Layouts aktuell gesetzt werden."
             ) ;_ end prompt
            )
            ((and
               (/= (getvar "ctab") (car LAYOUTLST))
                                        ; One layout that is not the current layout
               (= 1 (length LAYOUTLST)) ; with vpfreeze referenced layer(s)
             ) ;_ end and
             (terpri)
             ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (prompt "\nThere is one other layout that references one or more of the selected layers.")
;;;              (prompt "\nIn order for this command to continue this layout will need to be set current." )
             (prompt
               "\nEs gibt ein weiteres Layout, das mindestens 1 der gewhlten Layer referenziert."
             ) ;_ end prompt
             (prompt
               "\nUm diesen Befehl fortzusetzen, muss dieses Layouts aktuell gesetzt werden."
             ) ;_ end prompt
            )
          ) ;_ end cond

          (if (and VPON (= (xstrcase MODE) "DELETE"))
            (progn
              (terpri)
              ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (prompt "\nThere are one or more paperspace viewports that are on one of the")
;;;              (prompt "\nselected layers. THESE VIEWPORTS WILL BE DELETED.")
              (prompt
                "\nEs gibt ein oder mehrere Layout-Ansichtsfenster, die auf einem"
              ) ;_ end prompt
              (prompt
                "\nder gewhlten Layer liegen. DIESE ANSICHTSFENSTER WERDEN GELSCHT!"
              ) ;_ end prompt
            ) ;_ end progn
          ) ;_ end if

          (textscr)
          (terpri)
          ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;          (initget "Yes No _Yes No")
;;;          (setq PASS (getkword "\nDo you wish to continue? [Yes/No] <No>:")
;;;                PASS (if PASS PASS "No")
;;;          )
          (initget "Ja Nein _Yes No")
          (setq PASS (getkword
                       "\nWollen Sie wirklich fortfahren? [Ja/Nein] <Nein>:"
                     ) ;_ end getkword
                PASS (if PASS
                       PASS
                       "No"
                     ) ;_ end if
          ) ;_ end setq
        ) ;_ end progn
      ) ;_ end if
    ) ;_ end if

    (cond
      ((= PASS "Yes")                   ; If layout switching is needed
       (setq LAYOUTLST (cons (getvar "ctab") LAYOUTLST))
                                        ; add the current layout to the list
      )
      ((= PASS "No")                    ; If cancel is desired
       (setq LAYOUTLST NIL)             ; return nil
      )
      (t
       (setq LAYOUTLST (list (getvar "ctab")))
                                        ; otherwise just return the current layout
      )
    ) ;_ end cond
    LAYOUTLST
  ) ;_ end defun ACET-LYDELMRG-VPCHECK

;;; ----------------------------------------------------------------
;;;                          MAIN PROGRAM
;;; ----------------------------------------------------------------

  (ACET-ERROR-INIT
    (list
      (list "cmdecho" 0 "cecolor" "bylayer" "pickstyle" 0) ;_ end list
      t                                 ;flag. True means use undo for error clean up.
      '(if
        (and (= (xstrcase MODE) "MERGE") LAYLST)
        (foreach
         LAY
         LAYLST
         (setq
          SS
          (ssget "_x" (list (cons 8 LAY)))
          CNT
          0
         )
         (while
          (and
           SS
           (> (sslength SS) 0)
           (setq EN (ssname SS CNT))
          )                             ;and
          (redraw EN 4)
          (setq CNT (1+ CNT))
         )
        )
       )
    )                                   ; _list
  )                                     ; _acet-error-init


  (setq ANS  "START"
        LOOP t
        CLAY (getvar "clayer")
  ) ;_ end setq

  (command "_.undo" "_m")
  (while LOOP
    (cond
      ((not ANS)
       (setq LOOP NIL)
      )
      ((listp ANS)
       (setq LAY (cdr (assoc 8 (entget (car ANS)))))
      )
      ((= ANS "Type-it")
       ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;        (setq LAY (getstring "\nEnter layer name or [?]: " T))
       (setq LAY (getstring "\nLayernamen eingeben oder [?]: " t))
       (cond
         ((= LAY "")
          (setq ANS NIL
                LAY NIL
          ) ;_ end setq
         )
         ((= LAY "?")
          ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;            (setq STR (getstring "\nEnter layer name(s) to list <*>:"))
          (setq STR
                 (getstring "\nLayername(n) zum Auflisten eingeben <*>:")
          ) ;_ end setq
          (textscr)
          (setvar "qaflags" 2)
          (command "_.layer" "?" STR)
          (while (< 0 (getvar "cmdactive")) (command ""))
          (setvar "qaflags" 0)
          (setq LAY NIL)
         )
         ((setq LAY (tblobjname "LAYER" LAY))
          (setq LAY (cdr (assoc 2 (entget LAY))) ; get its real name
                ANS t
          ) ;_ end setq
         )
         (t
          ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;            (prompt "\nInvalid Layer name.")
          (prompt "\nUngltiger Layername!")
          (setq LAY NIL)
         )
       ) ;_ end cond
      )
      ((= ANS "Undo")
       (if LAYLST
         (progn
           (if (= (xstrcase MODE) "DELETE")
             (command "_.undo" "1")
           ) ;_ end if
           (if (= (xstrcase MODE) "MERGE")
             (progn
               (setq SS  (ssget "_x" (list (cons 8 (car LAYLST))))
                     CNT 0
               ) ;_ end setq
               (while (and SS
                           (> (sslength SS) 0)
                           (setq EN (ssname SS CNT))
                      )                 ;and
                 (redraw EN 4)
                 (setq CNT (1+ CNT))
               ) ;_ end while
             ) ;_ end progn
           ) ;_ end if
           (setq LAYLST (cdr LAYLST))
         ) ;_ end progn
         ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;          (prompt "\nEverything has been undone.")
         (prompt "\nEs wurde ALLES rckgngig gemacht.")
       ) ;_ end if
      )
    ) ;_ end cond

    (if LAY
      (cond
        ((= LAY "0")
         (if (= (xstrcase MODE) "DELETE")
           ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;            (prompt "\nCannot delete layer 0.")
;;;            (prompt "\nCannot merge layer 0.")
           (prompt "\nDer Layer 0 kann nicht gelscht werden!")
           (prompt "\nDer Layer 0 kann nicht verschoben werden!")
         ) ;_ end if
        )
;;;    ***ET2GP-Anpassung*** -> Anpassung an Gro-/Kleinschreibung:
;;;        ((= LAY "DEFPOINTS")
        ((= (strcase LAY) "DEFPOINTS")
         (if (= (xstrcase MODE) "DELETE")
           ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;            (prompt "\nCannot delete layer DEFPOINTS.")
;;;            (prompt "\nCannot merge layer DEFPOINTS.")
           (prompt "\nDer Layer DEFPOINTS kann nicht gelscht werden.")
           (prompt "\nDer Layer DEFPOINTS kann nicht verschoben werden.")
         ) ;_ end if
        )
        ((wcmatch LAY "*|*")
         (if (= (xstrcase MODE) "DELETE")
           ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;            (prompt (acet-str-format "\nLayer %1 is externally dependent and cannot be deleted." LAY))
;;;            (prompt (acet-str-format "\nLayer %1 is externally dependent and cannot be merged." LAY))
           (prompt
             (acet-str-format
               "\nDer Layer %1 gehrt zu einem XRef und kann daher nicht gelscht werden!"
               LAY
             ) ;_ end acet-str-format
           ) ;_ end prompt
           (prompt
             (acet-str-format
               "\nDer Layer %1 gehrt zu einem XRef und kann daher nicht verschoben werden!"
               LAY
             ) ;_ end acet-str-format
           ) ;_ end prompt
         ) ;_ if
        )
        ((and
           (= LAY CLAY)
           (= (xstrcase MODE) "DELETE")
         ) ;_ end and
         ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;          (prompt "\nCannot delete current layer.")
         (prompt "\nDer AKTUELLE Layer kann nicht gelscht werden!")
        )
        ((ACET-LAYER-LOCKED LAY)
         (if (= (xstrcase MODE) "DELETE")
           ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;            (prompt (acet-str-format "\nLayer %1 is locked and cannot be deleted." LAY))
;;;            (prompt (acet-str-format "\nLayer %1 is locked and cannot be merged." LAY))
           (prompt
             (acet-str-format
               "\nDer Layer %1 ist gesperrt und kann deshalb nicht gelscht werden!"
               LAY
             ) ;_ end acet-str-format
           ) ;_ end prompt
           (prompt
             (acet-str-format
               "\nDer Layer %1 ist gesperrt und kann deshalb nicht verschoben werden!"
               LAY
             ) ;_ end acet-str-format
           ) ;_ end prompt
         ) ;_ if
        )
        ((not (member LAY LAYLST))
         (setq LAYLST (if LAYLST
                        (append (list LAY) LAYLST)
                        (list LAY)
                      ) ;_ end if
         ) ;_ end setq
         (if (= (xstrcase MODE) "DELETE")
           (command "_.-layer" "_f" LAY "")
         ) ;_ end if
         (if (= (xstrcase MODE) "MERGE")
           (progn
             (setq SS  (ssget "_x" (list (cons 8 LAY)))
                   CNT 0
             ) ;_ end setq
             (while (and SS
                         (> (sslength SS) 0)
                         (setq EN (ssname SS CNT))
                    )                   ;and
               (redraw EN 3)
               (setq CNT (1+ CNT))
             ) ;_ end while
           ) ;_ end progn
         ) ;_ end if
        )
      ) ;_ end cond
    ) ;_ end if

    (if (and LOOP (/= ANS "Type-it"))
      (progn
        (setvar "errno" 7)
        (setq LAY NIL)
        (while (= (getvar "errno") 7)
          (setvar "errno" 0)
          ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;          (initget "Type-it Undo _Type-it Undo")
          (initget "Eingeben Zurck _Type-it Undo")
          (if LAYLST
            (progn
              (setq LAYSTR "")
              (foreach VAL LAYLST (setq LAYSTR (strcat LAYSTR VAL ",")))
              (setq LAYSTR (substr LAYSTR 1 (1- (strlen LAYSTR))))
              ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (prompt (acet-str-format "\nSelected layers: %1" LAYSTR))
              (prompt (acet-str-format "\nGewhlte Layer: %1" LAYSTR))
              (if (= (xstrcase MODE) "DELETE")
                ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                (setq ANS  (entsel "\nSelect object on layer to delete or [Type-it/Undo] <done>: "))
;;;                (setq ANS  (entsel "\nSelect object on layer to merge or [Type-it/Undo] <done>: "))
                (setq ANS
                       (entsel
                         "\nObjekt auf zu lschendem Layer whlen oder [Eingeben/Zurck] <fertig>: "
                       ) ;_ end entsel
                ) ;_ end setq
                (setq ANS
                       (entsel
                         "\nObjekt auf zu verschiebendem Layer whlen oder [Eingeben/Zurck] <fertig>: "
                       ) ;_ end entsel
                ) ;_ end setq
              ) ;_ end if
            ) ;_ end progn
            (if (= (xstrcase MODE) "DELETE")
              ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (setq ANS  (entsel "\nSelect object on layer to delete or [Type-it/Undo]: "))
;;;              (setq ANS  (entsel "\nSelect object on layer to merge or [Type-it/Undo]: "))
              (setq ANS
                     (entsel
                       "\nObjekt auf zu lschendem Layer whlen oder [Eingeben/Zurck]: "
                     ) ;_ end entsel
              ) ;_ end setq
              (setq ANS
                     (entsel
                       "\nObjekt auf zu verschiebendem Layer whlen oder [Eingeben/Zurck]: "
                     ) ;_ end entsel
              ) ;_ end setq
            ) ;_ end if
          ) ;_ end if
          (if (= (getvar "errno") 7)
            ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;            (prompt "\nNothing selected.")
            (prompt "\nNichts gewhlt!")
          ) ;_ end if
        ) ;_ end while
      ) ;_ end progn
    ) ;_ end if
  )                                     ; while LOOP


  (if LAYLST
    (progn

;;; ----------------------- build BLKLST ---------------------------
;;; BLKLST has the form: (("blk1" "lay1") ("blk2" "lay1" "lay2")...)
;;; ----------------------------------------------------------------

      (foreach LAY LAYLST               ; Check each layer selected
        (setq LST (ACET-LYDELMRG-LAYINBLKLST LAY))
                                        ; if it is referenced in a block
        (if (and LST (not BLKLST))      ; if so and no BLKLST
          (setq BLKLST                  ; build BLK LST
                 (mapcar '(lambda (X)
                            (list X LAY)
                          ) ;_ end lambda
                         LST
                 ) ;_ end mapcar
          ) ;_ end setq
          (foreach BLK LST              ; else go through each referenced block
            (if (setq VAL (assoc BLK BLKLST))
                                        ; if the block already is in BLKLST
              (setq BLKLST (subst (append VAL (list LAY)) VAL BLKLST))
                                        ; update the entry to include layer
              (setq BLKLST (append BLKLST (list (list BLK LAY))))
                                        ; else make a new entry
            ) ;_ end if
          ) ;_ end foreach
        ) ;_ end if
      ) ;_ end foreach

      (cond

;;; ------------------------ Layer Delete --------------------------

        ((= (xstrcase MODE) "DELETE")
;;;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;          (prompt "\n******** WARNING ********")
         (prompt "\n******** WARNUNG ********")
         (if BLKLST
           (progn
             (textscr)
             (terpri)
             ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;          (prompt (acet-str-format "\nThere are %1 block definition(s) which reference the layer(s) you are deleting."
;;;                     (rtos (length BLKLST) 2 0)
;;;                   ))
;;;          (prompt (strcat "\nThe block(s) will be redefined and the entities referencing the layer(s)\nwill be removed from the block definition(s)."))

             (setq ZAHL   (length BLKLST)
                   STRING (rtos ZAHL 2 0)
             ) ;_ end setq
             (if (= ZAHL 1)
               (prompt
                 (acet-str-format
                   "\n%1 Blockdefinition referenziert die Layer, die Sie gerade lschen."
                   STRING
                 ) ;_ end acet-str-format
               ) ;_ end prompt
               (prompt
                 (acet-str-format
                   "\n%1 Blockdefinitionen referenzieren die Layer, die Sie gerade lschen."
                   STRING
                 ) ;_ end acet-str-format
               ) ;_ end prompt
             ) ;_ end if prompt 1
             (if (= ZAHL 1)
               (prompt
                 (strcat
                   "\nDieser Block wird neu definiert, wobei die Objekte dieser Layer gelscht werden!"
                 ) ;_ end acet-str-format
               ) ;_ end prompt
               (prompt
                 (strcat
                   "\nDiese Blcke werden neu definiert, wobei die Objekte dieser Layer gelscht werden!"
                 ) ;_ end acet-str-format
               ) ;_ end prompt
             ) ;_ end if prompt 2
           ) ;_ end progn
         ) ;_ end if BLKLST
         (terpri)
         (if (= (length LAYLST) 1)
           ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;            (prompt (acet-str-format "\nYou are about to permanently delete layer %1 from this drawing."  (car LAYLST)))
           (prompt
             (acet-str-format
               "\nSie werden den Layer %1 ENDGLTIG aus dieser Zeichnung entfernen."
               (car LAYLST)
             ) ;_ end acet-str-format
           ) ;_ end prompt
           (progn
             (textscr)
             ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (prompt "\nYou are about to permanently delete the following layers from this drawing:\n")
             (prompt
               "\nSie werden folgende Layer ENDGLTIG aus dieser Zeichnung entfernen:\n"
             ) ;_ end prompt
             (foreach LAY LAYLST
               (prompt (strcat "\n" LAY))
             ) ;_ end foreach
             (terpri)
           ) ;_ end progn
         ) ;_ end if
         ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;          (initget "Yes No _Yes No")
;;;          (setq PASS (getkword "\nDo you wish to continue? [Yes/No] <No>:"))
         (initget "Ja Nein _Yes No")
         (setq PASS
                (getkword
                  "\nWollen Sie wirklich fortfahren? [Ja/Nein] <Nein>:"
                ) ;_ end getkword
         ) ;_ end setq
         (setq PASS (if (null PASS)
                      "No"
                      PASS
                    ) ;_ end if
         )                              ;setq 
         (if (and
               (= PASS "Yes")
               (setq LAYOUTLST (ACET-LYDELMRG-VPCHECK LAYLST MODE))
             ) ;_ end and

           (progn
             (setq FLTR (mapcar '(lambda (X) (cons 8 X)) LAYLST)
                   ;; Make a layer filter list
                   FLTR (append '((-4 . "<OR")) FLTR '((-4 . "OR>")))
             ) ;_ end setq

             (if BLKLST                 ; Clean up block table
               (foreach BLK BLKLST      ; by going through each block in BLKLST
                 (ACET-LYDELMRG-BLKREDEF
                   (car BLK)
                   (cdr BLK)
                   MODE
                   NEWLAY
                 )                      ; and removing the referencing entities
               ) ;_ end foreach
             ) ;_ end if


             (progn
               (setq CLAYOUT (getvar "ctab")
                     CVPORT  (getvar "cvport")
               ) ;_ end setq
               (foreach LAYOUT LAYOUTLST
                 (setvar "ctab" LAYOUT)
                 (if (/= LAYOUT "Model")
                   (progn
                     (command "_.pspace")
                     (command "_.vplayer" "_t" LAYSTR "_a" "")
                   ) ;_ end progn
                 ) ;_ end if
                 (if (setq SS (ssget "_x" FLTR))
                   (command "_.erase" SS "")
                 ) ;_ end if
               ) ;_ end foreach
               (setvar "ctab" CLAYOUT)

               (if (and (/= CLAYOUT "Model")
                        (< 1 CVPORT)
                        (ssget "_x" '((0 . "VIEWPORT")))
                   ) ;_ end and
                 (command "_.mspace")
               ) ;_ end if
             ) ;_ end progn

             (if (setq SS (ssget "_x" FLTR))
               (progn
                 (setq CNT 0)
                 (while (and SS
                             (> (sslength SS) 0)
                             (setq EN (ssname SS CNT))
                        )               ;and
                   (entdel EN)
                   (setq CNT (1+ CNT))
                 ) ;_ end while
               ) ;_ end progn
             ) ;_ end if

             (foreach LAY LAYLST
               (ACET-LYDELMRG-ATTREDEF LAY MODE NEWLAY)
                                        ; Recreate inserts which reference LAY
               (terpri)
             ) ;_ end foreach

             (if (BNS_TBL_MATCH "block" '((2 . "`*D*")))
               (ACET-SAFE-COMMAND
                 t
                 t
                 (list "_.purge" "_block" "`*D*" "_n")
                                        ; Purge all anonymous dim blocks
               ) ;_ end acet-safe-command
             )                          ;if

             (ACET-SAFE-COMMAND
               t
               t
               (list "_.purge" "_layer" LAYSTR "_n")
             )                          ; Purge all the layers

             (foreach LAY LAYLST
               (if (tblobjname "LAYER" LAY)
                 (setq NOPURGE_LST (append NOPURGE_LST (list LAY)))
               ) ;_ end if
             ) ;_ end foreach

             (if NOPURGE_LST
               (progn
                 (if (< 1 (length NOPURGE_LST))
                   (progn
                     (setq LAYSTR "\n")
                     (foreach VAL NOPURGE_LST
                       (setq LAYSTR (strcat LAYSTR VAL "\n"))
                     ) ;_ end foreach
                     ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                      (setq ALERT_STRING
;;;                        (acet-str-format "The following Layers could not be purged because they\nare being referenced by some object(s) in the drawing:\n%1"
;;;                          LAYSTR
;;;                        )
;;;                      )
                     (setq ALERT_STRING
                            (acet-str-format
                              "Die folgenden Layer knnen nicht bereinigt werden,\nweil sie von mindestens 1 Objekt der Zeichnung referenziert werden:\n%1"
                              LAYSTR
                            ) ;_ end acet-str-format
                     ) ;_ end setq
                   ) ;_ end progn xx
                   ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                    (setq ALERT_STRING
;;;                      (acet-str-format "Layer %1 could not be purged because\nit is being referenced by some object(s) in the drawing."
;;;                        (car NOPURGE_LST)
;;;                      )
;;;                    )
                   (setq ALERT_STRING
                          (acet-str-format
                            "Der Layer %1 konnte nicht bereinigt werden,\nweil er von mindestens 1 Objekt der Zeichnung referenziert wird."
                            (car NOPURGE_LST)
                          ) ;_ end acet-str-format
                   ) ;_ end setq
                 ) ;_ end if
                 (ACET-ALERT ALERT_STRING)
               ) ;_ end progn
             ) ;_ end if NOPURGE_LST
           ) ;_ end progn

           (progn
             ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (prompt "\nOperation aborted.")
             (prompt "\nVorgang abgebrochen.")
             (command "_.undo" "_b")
           ) ;_ end progn
         ) ;_ end if 
        ) ;_ end if (= (xstrcase MODE) "DELETE")

;;; ------------------------- Layer Merge --------------------------

        ((= (xstrcase MODE) "MERGE")

         (setq ANS t
               LOOP t
         ) ;_ end setq

         (while LOOP
           (cond
             ((not ANS)
              (setq LOOP NIL)
             )
             ((listp ANS)
              (setq NEWLAY (cdr (assoc 8 (entget (car ANS))))
                    LOOP   NIL
              ) ;_ end setq
             )
             ((= ANS "Type-it")
              ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                (setq NEWLAY (getstring "\nEnter layer name or [?]: " T))
              (setq
                NEWLAY (getstring "\nLayernamen eingeben oder [?]: "
                                  t
                       ) ;_ end getstring
              ) ;_ end setq
              (cond
                ((= NEWLAY "")
                 (setq ANS NIL
                       NEWLAY NIL
                 ) ;_ end setq
                )
                ((= NEWLAY "?")
                 ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                    (setq STR (getstring "\nEnter layer name(s) to list <*>:"))
                 (setq
                   STR (getstring
                         "\nLayernamen zum Auflisten eingeben <*>:"
                       ) ;_ end getstring
                 ) ;_ end setq
                 (textscr)
                 (setvar "qaflags" 2)
                 (command "_.layer" "?" STR)
                 (while (< 0 (getvar "cmdactive")) (command ""))
                 (setvar "qaflags" 0)
                )
                ((setq NEWLAY (tblobjname "LAYER" NEWLAY))
                 (setq NEWLAY (cdr (assoc 2 (entget NEWLAY)))
                                        ; get its real name
                       LOOP   NIL
                 ) ;_ end setq
                )
                (t
                 ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                    (prompt "\nInvalid Layer name.")
                 (prompt "\nUngltiger Layername.")
                 (setq NEWLAY NIL)
                )
              ) ;_ end cond
             )
           ) ;_ end cond

           (if (and NEWLAY (not LOOP))
             (cond
               ((member NEWLAY LAYLST)
                ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                  (prompt "\nCannot merge a layer with itself.")
                (prompt
                  "\nEin Layer kann nicht auf sich selbst verschoben werden!"
                ) ;_ end prompt
                (setq LOOP t)
               )
               ((wcmatch NEWLAY "*|*")
                ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;               (prompt (acet-str-format "\nLayer %1 is externally dependent and cannot be used."  NEWLAY ))
                (prompt
                  (acet-str-format
                    "\nDer Layer %1 gehrt zu einem XRef und kann deshalb nicht verwendet werden."
                    NEWLAY
                  ) ;_ end acet-str-format
                ) ;_ end prompt
                (setq LOOP t)
               )
             ) ;_ end cond
           ) ;_ end if

           (if (and LOOP (/= ANS "Type-it"))
             (progn
               (setvar "errno" 7)
               (terpri)
               (while (= (getvar "errno") 7)
                 (setvar "errno" 0)
                 ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                  (initget "Type-it _Type-it")
;;;                  (setq ANS  (entsel "\rSelect object on target layer or [Type-it]: "))
                 (initget "Eingeben _Type-it")
                 (setq
                   ANS (entsel
                         "\rObjekt auf Ziel-Layer oder [Eingeben]: "
                       ) ;_ end entsel
                 ) ;_ end setq
                 (if (= (getvar "errno") 7)
                   ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                    (prompt "\nNothing selected.")
                   (prompt "\nNichts gewhlt.")
                 ) ;_ end if
               ) ;_ end while
             ) ;_ end progn
           ) ;_ end if
         )                              ; while LOOP

         (if NEWLAY
           (progn
             (terpri)
             ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (prompt "\n******** WARNING ********")
             (prompt "\n******** WARNUNG ********")
             (if BLKLST
               (progn
                 (textscr)
                 (terpri)
                 ;; ***ET2GP-Anpassung*** -> Dialog bersetzt und Unterscheidung Einzahl/Mehrzahl
;;;                  (prompt (acet-str-format "\nThere are %1 block definition(s) which reference the layer(s) you are deleting."
;;;                            (rtos (length BLKLST) 2 0)
;;;                           )
;;;                  )
;;;                  (prompt (acet-str-format "\nThe block(s) will be redefined and the entities referencing\nthe layer(s) will be changed to reference layer %1." NEWLAY))

                 (setq ZAHL   (length BLKLST)
                       STRING (rtos ZAHL 2 0)
                 ) ;_ end setq
                 (if (= ZAHL 1)
                   (prompt
                     (acet-str-format
                       "\n%1 Blockdefinition referenziert die Layer, die Sie gerade lschen."
                       STRING
                     ) ;_ end acet-str-format
                   ) ;_ end prompt
                   (prompt
                     (acet-str-format
                       "\n%1 Blockdefinitionen referenzieren die Layer, die Sie gerade lschen."
                       STRING
                     ) ;_ end acet-str-format
                   ) ;_ end prompt
                 )                      ;end if
                 (if (= ZAHL 1)
                   (prompt
                     (acet-str-format
                       "\nDieser Block wird neu definiert, wobei die Objekte dieser Layer \nauf den Layer %1 verschoben werden."
                       NEWLAY
                     ) ;_ end acet-str-format
                   ) ;_ end prompt
                   (prompt
                     (acet-str-format
                       "\nDiese Blcke werden neu definiert, wobei die Objekte dieser Layer \nauf den Layer %1 verschoben werden."
                       NEWLAY
                     ) ;_ end acet-str-format
                   ) ;_ end prompt
                 )                      ;end if
               ) ;_ end progn
             ) ;_ end if
             (terpri)

             (if (= (length LAYLST) 1)
               ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                (prompt acet-str-format "\nYou are about to permanently merge layer %1 into layer %2." (car LAYLST) NEWLAY))
               (prompt
                 (acet-str-format
                   "\nSie werden den Layer %1 ENDGLTIG auf den Layer %2 verschieben."
                   (car LAYLST)
                   NEWLAY
                 ) ;_ end acet-str-format
               ) ;_ end prompt
               (progn
                 (textscr)
                 ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                  (prompt (acet-str-format "\nYou are about to permanently merge the following layers into layer %1:\n"  NEWLAY ))
                 (prompt
                   (acet-str-format
                     "\nSie werden folgende Layer ENDGLTIG auf den Layer %1 verschieben:\n"
                     NEWLAY
                   ) ;_ end acet-str-format
                 ) ;_ end prompt
                 (foreach LAY LAYLST
                   (prompt (strcat "\n" LAY))
                 ) ;_ end foreach
                 (terpri)
               ) ;_ end progn
             ) ;_ end if
             ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (initget "Yes No _Yes No")
;;;              (setq PASS (getkword "\nDo you wish to continue? [Yes/No] <No>:"))
             (initget "Ja Nein _Yes No")
             (setq PASS
                    (getkword
                      "\nWollen Sie wirklich fortfahren? [Ja/Nein] <Nein>:"
                    ) ;_ end getkword
             ) ;_ end setq
             (setq PASS (if (null PASS)
                          "No"
                          PASS
                        ) ;_ end if
             ) ;_ end setq
             (graphscr)

             (if
               (and
                 (= PASS "Yes")
                 (setq LAYOUTLST (ACET-LYDELMRG-VPCHECK LAYLST MODE))
               ) ;_ end and
                (progn

                  (if BLKLST
                    (foreach BLK BLKLST
                      (ACET-LYDELMRG-BLKREDEF
                        (car BLK)
                        (cdr BLK)
                        MODE
                        NEWLAY
                      ) ;_ end acet-lydelmrg-blkredef
                    ) ;_ end foreach
                  ) ;_ end if

                  (if (member CLAY LAYLST)
                    (setvar "clayer" NEWLAY)
                  ) ;_ end if

                  (setq CLAYOUT (getvar "ctab")
                        CVPORT  (getvar "cvport")
                  ) ;_ end setq

                  (foreach LAYOUT LAYOUTLST
                    (setvar "ctab" LAYOUT)

                    (if (/= LAYOUT "Model")
                      (progn
                        (command "_.pspace")
                        (command "_.vplayer" "_t" LAYSTR "_a" "")
                      ) ;_ end progn
                    ) ;_ end if

                    (foreach LAY LAYLST
                      (terpri)
                      ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                      (princ (acet-str-format "\nMerging layer %1 into layer %2." LAY NEWLAY))
                      (princ
                        (acet-str-format
                          "\nDer Layer %1 wird auf den Layer %2 verschoben."
                          LAY
                          NEWLAY
                        ) ;_ end acet-str-format
                      ) ;_ end princ

                      (setq FLTR (list '(-4 . "<AND")
                                       (cons 8 LAY)
                                       (cons 410 LAYOUT)
                                       '(-4 . "AND>")
                                 ) ;_ end list
                      ) ;_ end setq

                      (if (setq SS (ssget "_x" FLTR))
                        (command "_.chprop" SS "" "_layer" NEWLAY "")
                      ) ;_ end if

                      (if (setq SS (ssget "_x" FLTR))
                        (progn
                          (setq CNT 0)
                          (while (and SS
                                      (> (sslength SS) 0)
                                      (setq EN (ssname SS CNT))
                                 )      ;and
                            (setq EN (entget EN '("*"))
                                  EN (subst (cons 8 NEWLAY)
                                            (assoc 8 EN)
                                            EN
                                     ) ;_ end subst
                            ) ;_ end setq
                            (entmod EN)
                            (setq CNT (1+ CNT))
                          ) ;_ end while
                        ) ;_ end progn
                      ) ;_ end if
                    ) ;_ end foreach
                    (setvar "ctab" CLAYOUT)

                    (if (and (/= CLAYOUT "Model")
                             (< 1 CVPORT)
                             (ssget "_x" '((0 . "VIEWPORT")))
                        ) ;_ end and
                      (command "_.mspace")
                    ) ;_ end if
                  ) ;_ end foreach

                  (foreach LAY LAYLST
                    (ACET-LYDELMRG-ATTREDEF LAY MODE NEWLAY)
                                        ; Recreate inserts which reference LAY
                    ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                   (prompt (acet-str-format "\nAll entities which were on layer %1 have been moved to layer %2." LAY NEWLAY))
                    (prompt
                      (acet-str-format
                        "\nAlle Objekte des Layers %1 wurden auf den Layer %2 verschoben."
                        LAY
                        NEWLAY
                      ) ;_ end acet-str-format
                    ) ;_ end prompt
                  ) ;_ end foreach
                  (terpri)
                  (ACET-SAFE-COMMAND
                    t
                    t
                    (list "_.purge" "_layer" LAYSTR "_n")
                  ) ;_ end acet-safe-command
                  (foreach LAY LAYLST
                    (if (tblobjname "LAYER" LAY)
                      (setq NOPURGE_LST
                             (append NOPURGE_LST (list LAY))
                      ) ;_ end setq
                    ) ;_ end if
                  ) ;_ end foreach
                  (if NOPURGE_LST
                    (progn
                      (if (< 1 (length NOPURGE_LST))
                        (progn
                          (setq LAYSTR "\n")
                          (foreach VAL NOPURGE_LST
                            (setq LAYSTR (strcat LAYSTR VAL "\n"))
                          ) ;_ end foreach
                          ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                          (setq ALERT_STRING
;;;                            (acet-str-format "The following Layers could not be purged because they\nare being referenced by some object(s) in the drawing:\n%1"
;;;                                  LAYSTR
;;;                            )
;;;                          )
                          (setq ALERT_STRING
                                 (acet-str-format
                                   "Die folgenden Layer knnen nicht bereinigt werden,\nweil sie von mindestens 1 Objekt der Zeichnung referenziert werden:\n%1"
                                   LAYSTR
                                 ) ;_ end acet-str-format
                          ) ;_ end setq
                        ) ;_ end progn
                        ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                        (setq ALERT_STRING
;;;                          (acet-str-format "Layer %1 could not be purged because\nit is being referenced by some object(s) in the drawing."
;;;                            (car NOPURGE_LST) )
;;;                        )
                        (setq ALERT_STRING
                               (acet-str-format
                                 "Der Layer %1 konnte nicht bereinigt werden,\nweil er von mindestens 1 Objekt der Zeichnung referenziert wird."
                                 (car NOPURGE_LST)
                               ) ;_ end acet-str-format
                        ) ;_ end setq
                      ) ;_ end if
                      (ACET-ALERT ALERT_STRING)
                    ) ;_ end progn
                  ) ;_ end if

                ) ;_ end progn

                (progn
                  ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                  (prompt "\nOperation aborted.")
                  (prompt "\nVorgang abgebrochen.")
                  (foreach LAY LAYLST
                    (setq SS  (ssget "_x" (list (cons 8 LAY)))
                          CNT 0
                    ) ;_ end setq
                    (while (and SS
                                (> (sslength SS) 0)
                                (setq EN (ssname SS CNT))
                           )            ;and
                      (redraw EN 4)
                      (setq CNT (1+ CNT))
                    ) ;_ end while
                  ) ;_ end foreach
                ) ;_ end progn
             ) ;_ end if
           ) ;_ end progn
           (progn
             ;; ***ET2GP-Anpassung*** -> Dialog bersetzt
;;;              (prompt "\nOperation aborted.")
             (prompt "\nVorgang abgebrochen.")
             (foreach LAY LAYLST
               (setq SS  (ssget "_x" (list (cons 8 LAY)))
                     CNT 0
               ) ;_ end setq
               (while (and SS
                           (> (sslength SS) 0)
                           (setq EN (ssname SS CNT))
                      )                 ;and
                 (redraw EN 4)
                 (setq CNT (1+ CNT))
               ) ;_ end while
             ) ;_ end foreach
           ) ;_ end progn
         ) ;_ end if NEWLAY
        ) ;_ (= (xstrcase MODE) "MERGE")
      ) ;_ end cond
    ) ;_ end progn
    (setvar "clayer" CLAY)
  ) ;_ end if

  (ACET-ERROR-RESTORE)                  ; Restore values
  (princ)
) ;_ end defun ACET-LYDELMRG-MAIN

(princ)
