/// *******************************************************************
/// *                                                                 *
/// * Wir sind das "Express-Tools 2 German Project"                   *
/// * Nachfolgend nur nach abgekrzt durch "ET2GP" !                  *
/// * --------------------------------------------------------------- *
/// * Die Beteiligten in alphabetischer Reihenfolge:                  *
/// *                                                                 *
/// * Vorname, Name      E-Mail-Adresse             Website           *
/// * --------------------------------------------------------------- *
/// * Holger Brischke       kontakt@defun.de        www.defun.de      *
/// * Martin Drese          drese@defun.de          keine Website     *
/// * Markus Hoffmann       hoffmann@defun.de       keine Website     *
/// * Marc Scherer          marc.scherer@zvo.com    keine Website     *
/// * Peter Tropf           info@petertropf.de      keine Website     *
/// *                                                                 *
/// * Special Guest (bersetzung der Hilfe-Texte)                     *
/// * Walter Verburg        walterverburg@web.de    keine Website     *
/// *******************************************************************
/// 
/// ***ET2GP-Anpassung*** ->Kommentar
/// Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
/// originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
/// Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
/// mchtig ist, haben wir diese bersetzung vorgenommen.
/// 
/// nderungen an den Originaltexten sind immer mit einem einleitenden
/// Kommentar versehen, wobei die Steuerzeichen fr Kommentar je nach
/// Dateiart variiert:
///
/// Eine nderung an einer Lisp-Datei ist folgendermaen markiert:
/// 
/// ;;; ***ET2GP-Anpassung*** ..."
/// 
/// Bei einem DCL-File dann so:
///
/// "/// ***ET2GP-Anpassung*** ..." 
/// 
/// Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
/// ein "Auskommentieren" deaktiviert.
/// 
/// Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
/// deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.
/// 
/// Beispiel:
/// ...
/// ;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
///          ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
///          (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
/// ...
/// 
/// Jede angepasste Datei wird mit diesem Header vorneweg versehen wobei die
/// nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
/// natrlich variabel sind.
/// 
/// ***ET2GP-Anpassung*** -> Kommentar
/// Version 1.0
/// 24.07.2003
/// Markus Hoffmann
//
//
//    SPRHATCH.DCL
//    Copyright  1999 by Autodesk, Inc.
//
//    Your use of this software is governed by the terms and conditions of the
//    License Agreement you accepted prior to installation of this software.
//    Please note that pursuant to the License Agreement for this software,
//    "[c]opying of this computer program or its documentation except as
//    permitted by this License is copyright infringement under the laws of
//    your country.  If you copy this computer program without permission of
//    Autodesk, you are violating the law."
//
//    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//    UNINTERRUPTED OR ERROR FREE.
//
//    Use, duplication, or disclosure by the U.S. Government is subject to
//    restrictions set forth in FAR 52.227-19 (Commercial Computer
//    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//    (Rights in Technical Data and Computer Software), as applicable.
//
//  ----------------------------------------------------------------

sprhatch : dialog {
/// ***ET2GP-Anpassung*** Dialogtitel gendert
///  label = "SuperHatch";
  label = "SuperHatch - Superschraffur";
  : column {
    : boxed_column {
/// ***ET2GP-Anpassung*** Boxed-Titel gendert
///   label="Pattern Type";
      label="Mustertyp";
      //: column {
      : button {
        alignment=centered;
        fixed_width=true;
        width=22;
        key="image";
/// ***ET2GP-Anpassung*** Knopf-Label gendert
//      label="&Image...";
        label="&Bild...";
      }
      : button {
        alignment=centered;
        fixed_width=true;
        width=22;
        key="block";
/// ***ET2GP-Anpassung*** Mnemonic key gendert
        label="B&lock...";
      }
      : button {
        alignment=centered;
        fixed_width=true;
        width=22;
        key="xref";
/// ***ET2GP-Anpassung*** Knopf-Label gendert
//      label="&Xref Attach...";
        label="&XRef zuordnen...";
      }
      : button {
        alignment=centered;
        fixed_width=true;
        width=22;
        key="wipeout";
        label="&Wipeout...";
      }
      spacer;
      spacer;
      : button {
        alignment=centered;
        fixed_width=true;
        width=22;
        key="select";
/// ***ET2GP-Anpassung*** Knopf-Label gendert
//      label= "&Select existing <";
        label= "&Vorhandenes Element <";
      }
      //} // column
    } // boxed column
    spacer;
    : boxed_row {
/// ***ET2GP-Anpassung*** Boxed-Titel gendert
//    label = "Curve error tolerance:";
      label = "Kurvenfehlertoleranz:";
      : edit_box {
        key = "clipitres";
        fixed_width=true;
        width=20;
      } //edit_box
    } // boxed row
    spacer;
  } // column
  : row {
    : button {
      fixed_width=true;
      width=11;
      is_cancel=true;
      key="cancel";
/// ***ET2GP-Anpassung*** Knopf-Label gendert
//    label= "Cancel";
      label= "Abbruch";
    }
    : button {
      fixed_width=true;
      width=11;
      key="help";
/// ***ET2GP-Anpassung*** Knopf-Label gendert
//    label= "&Help";
      label= "&Hilfe";
      is_help=true;
    }
  } // row
  : text_part
  {
    key="error";
    label="";
  }
}
