/// *******************************************************************
/// *                                                                 *
/// * Wir sind das "Express-Tools 2 German Project"                   *
/// * Nachfolgend nur nach abgekrzt durch "ET2GP" !                  *
/// * --------------------------------------------------------------- *
/// * Die Beteiligten in alphabetischer Reihenfolge:                  *
/// *                                                                 *
/// * Vorname, Name      E-Mail-Adresse             Website           *
/// * --------------------------------------------------------------- *
/// * Holger Brischke       kontakt@defun.de        www.defun.de      *
/// * Martin Drese          drese@defun.de          keine Website     *
/// * Markus Hoffmann       hoffmann@defun.de       keine Website     *
/// * Marc Scherer          marc.scherer@zvo.com    keine Website     *
/// * Peter Tropf           info@petertropf.de      keine Website     *
/// *                                                                 *
/// * Special Guest (bersetzung der Hilfe-Texte)                     *
/// * Walter Verburg        walterverburg@web.de    keine Website     *
/// *******************************************************************
/// 
/// ***ET2GP-Anpassung*** ->Kommentar
/// Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
/// originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
/// Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
/// mchtig ist, haben wir diese bersetzung vorgenommen.
/// 
/// nderungen an den Originaltexten sind immer mit einem einleitenden
/// Kommentar versehen, wobei die Steuerzeichen fr Kommentar je nach
/// Dateiart variiert:
///
/// Eine nderung an einer Lisp-Datei ist folgendermaen markiert:
/// 
/// ;;; ***ET2GP-Anpassung*** ..."
/// 
/// Bei einem DCL-File dann so:
///
/// "/// ***ET2GP-Anpassung*** ..." 
/// 
/// Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
/// ein "Auskommentieren" deaktiviert.
/// 
/// Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
/// deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.
/// 
/// Beispiel:
/// ...
/// ;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
///          ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
///          (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
/// ...
/// 
/// Jede angepasste Datei wird mit diesem Header vorneweg versehen wobei die
/// nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
/// natrlich variabel sind.
/// 
/// ***ET2GP-Anpassung*** -> Kommentar
/// Version 1.0
/// Oktober 2003
/// Martin Drese
//
//
//    tcase.dcl
//    Copyright  1998 by Autodesk, Inc.
//
//    Permission to use, copy, modify, and distribute this software
//    for any purpose and without fee is hereby granted, provided
//    that the above copyright notice appears in all copies and
//    that both that copyright notice and the limited warranty and
//    restricted rights notice below appear in all supporting
//    documentation.
//
//    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//    UNINTERRUPTED OR ERROR FREE.
//
//    Use, duplication, or disclosure by the U.S. Government is subject to
//    restrictions set forth in FAR 52.227-19 (Commercial Computer
//    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//    (Rights in Technical Data and Computer Software), as applicable.
//
//  ----------------------------------------------------------------

tcase : dialog {
/// ***ET2GP-Anpassung*** (gendert von Peter Tropf)
///  label = "TCASE - change text case";
  label = "TCASE - Gro-/Kleinschreibung ndern";
  : boxed_column {
   : radio_column {

    : radio_button {
    /// ***ET2GP-Anpassung*** ...
    ///  label = "Sentence case.";
      label = "Nur der 1. Buchstabe GROSS";
      key = "sentence";
      mnemonic = "N";
    }
    : radio_button {
    /// ***ET2GP-Anpassung*** ...
    ///  label = "lowercase";
      label = "Alles in Kleinbuchstaben";
      key = "lower";
      mnemonic = "K";
    }
    : radio_button {
    /// ***ET2GP-Anpassung*** ...
    ///  label = "UPPERCASE";
      label = "Alles in GROSSbuchstaben";
      key = "upper";
      mnemonic = "G";
      fixed_width = true;
    }
    : radio_button {
    /// ***ET2GP-Anpassung*** ...
    ///  label = "Title";
      label = "Der 1. Buchstabe bei jedem Wort GROSS";
      key = "title";
      mnemonic = "D";
      fixed_width = true;
    }
    : radio_button {
    /// ***ET2GP-Anpassung*** ...
    ///  label = "tOGGLE cASE.";
    ///  label = "ferschIEDENe fLLE."; gendert von Peter Tropf:
      label = "Die Gro-/Kleinschreibung tauschen";
      key = "toggle";
      mnemonic = "t";
      fixed_width = true;
    }

   } // radio column
  } // boxed column
  spacer;
  : row
  {
    : button {
      fixed_width=true;
      width=11;
      key="accept";
      is_default=true;
      label= "OK";
    }
    : button {
      fixed_width=true;
      width=11;
      is_cancel=true;
      key="cancel";
      /// ***ET2GP-Anpassung*** ...
      /// label= "Cancel";
      label= "Abbrechen";
    }
    : button {
      fixed_width=true;
      width=11;
      key="help";
      /// ***ET2GP-Anpassung*** ...
      /// label= "&Help";
      label= "&Hilfe";
      is_help=true;
    }
  } // row
}
