;|
*******************************************************************
*                                                                 *
* Wir sind das "Express-Tools 2 German Project"                   *
* Nachfolgend nur nach abgekrzt durch "ET2GP" !                  *
* --------------------------------------------------------------- *
* Die Beteiligten in alphabetischer Reihenfolge:                  *
*                                                                 *
* Vorname, Name         E-Mail-Adresse          Website           *
* --------------------------------------------------------------- *
* Holger Brischke       kontakt@defun.de        www.defun.de      *
* Martin Drese          drese@defun.de          keine Website     *
* Markus Hoffmann       hoffmann@defun.de       keine Website     *
* Marc Scherer          marc.scherer@zvo.com    keine Website     *
* Peter Tropf           info@petertropf.de      keine Website     *
*                                                                 *
* Special Guest (bersetzung der Hilfe-Texte)                     *
* Walter Verburg        walterverburg@web.de    keine Website     *
*                                                                 *
*******************************************************************

***ET2GP-Anpassung*** -> Kommentar
Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
mchtig ist, haben wir diese bersetzung vorgenommen.

nderungen an den Originaltexten sind immer mit einem einleitenden
Kommentar versehen, wobei die Steuerzeichen fr Kommentare je nach
Dateiart variieren:

Eine nderung an einer Lisp-Datei ist folgendermaen markiert:

;;; ***ET2GP-Anpassung*** ...

Bei einem DCL-File dann so:

/// ***ET2GP-Anpassung*** ...

Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
ein "Auskommentieren" deaktiviert.

Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.

Beispiel:
...
;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
         ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
         (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
...

Jede angepasste Datei wird mit diesem Header vorneweg versehen, wobei die
nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
natrlich variabel sind.

***ET2GP-Anpassung*** -> Kommentar
Version 1.0
02.08.2003
Martin Drese
|;
 
;;
;;;
;;;    TEXTFIT.LSP
;;;    Copyright  1999 by Autodesk, Inc.
;;;
;;;    Your use of this software is governed by the terms and conditions of the
;;;    License Agreement you accepted prior to installation of this software.
;;;    Please note that pursuant to the License Agreement for this software,
;;;    "[c]opying of this computer program or its documentation except as
;;;    permitted by this License is copyright infringement under the laws of
;;;    your country.  If you copy this computer program without permission of
;;;    Autodesk, you are violating the law."
;;;
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;;;    UNINTERRUPTED OR ERROR FREE.
;;;
;;;    Use, duplication, or disclosure by the U.S. Government is subject to
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
;;;    (Rights in Technical Data and Computer Software), as applicable.
;;;
;;;  ----------------------------------------------------------------

(defun c:textfit (/ ename textent newend tmp start newpt val ltc_% ss txtsz)
 
  (acet-error-init
    (list
        (list  "cmdecho"    0
               "snapang"    0
              "limcheck"    0
              "orthomode"  1
        )
        T     ;flag. True means use undo for error clean up.
     ) ;list
  );acet-error-init
 
;;;End Error control
 
  (if (not (and
              (setq ss (ssget "_i"))
              (= (sslength ss) 1)
              (setq ename (ssname ss 0)
              )
           )
      )
    ;;;***ET2GP-Anpassung*** -> Dialog bersetzt
;;;    (setq ename  (car (entsel "\nSelect Text to stretch or shrink:" )))
;;;    (setq ename  (car (entsel "\nWhle Text zum strecken oder schrumpfen:" )))
;;;    gendert von Peter Tropf:
    (setq ename  (car (entsel "\nWhlen Sie einen Text zum Strecken oder Schrumpfen:" )))
  )
 
 
  (cond
    ((not (setq textent (if ename (entget ename))))
     ;;;***ET2GP-Anpassung*** -> Dialog bersetzt
;;;      (princ "\nNo object selected!")
      (princ "\n*** Kein Objekt gewhlt! ***")
    )
    ((/= (acet-dxf 0 textent) "TEXT")
     ;;;***ET2GP-Anpassung*** -> Dialog bersetzt
;;;      (princ "\nSelected object is not Text!")
      (princ "\n*** Gewhltes Objekt ist kein Text! ***")
    )
    ((acet-layer-locked (acet-dxf 8 textent))
     ;;;***ET2GP-Anpassung*** -> Dialog bersetzt
;;;      (princ "\nSelected object is on a locked layer!")
      (princ "\n*** Gewhltes Objekt liegt auf einem gesperrten Layer! ***")
    )
    (t
      (setq txtsz (textbox textent))
      (setq newend (distance
                      (list
                        (caadr txtsz) ;upper right x coord
                        (cadar txtsz) ;lower left y coord
                      )
                      (car txtsz) ;; ll xyz
                   );distance
      );setq
      ;set snap along text entity
      (setvar "snapang"
        (angtof (angtos (acet-dxf 50 textent) 0 8) 0 )
      )
      (initget 0 "Start _Start")
     ;;;***ET2GP-Anpassung*** -> Dialog bersetzt
;;;      (setq
;;;        tmp (getpoint (acet-dxf 10 textent) "\nSpecify end point or [Start point]: ")
;;;      )
;;;      (setq tmp (getpoint (acet-dxf 10 textent) "\nZeige Endpunkt oder[Startpunkt]: "))
;;;   gendert von Peter Tropf:
      (setq tmp (getpoint (acet-dxf 10 textent) "\nEndpunkt eingeben oder [Startpunkt]: "))
      (setvar "snapang" 0)
      (cond
        ((= (type tmp) 'STR) ;;new starting point to be selected
         ;;;***ET2GP-Anpassung*** -> Dialog bersetzt
;;;          (setq start (getpoint "\nSpecify new starting point: "))
;;;          (setq start (getpoint "\nZeige neuen Statpunkt: "))
;;;           gendert von Peter Tropf:
          (setq start (getpoint "\nNeuen Startpunkt eingeben: "))
         (if start
            (progn
              (acet-ucs-cmd (list "_E" (acet-dxf -1 textent)))
              (setvar "orthomode" 1)
              (setq newpt
                (if start
                  ;;;***ET2GP-Anpassung*** -> Dialog bersetzt
;;;                  (getpoint (trans start 0 1) " ending point: ")
;;;                  (getpoint (trans start 0 1) " Endpunkt: ")
;;;                  gendert von Peter Tropf:
                  (getpoint (trans start 0 1) "\n neuen Endpunkt eingeben: ")
                  nil
                ) ;if
              ) ;setq
              (if newpt
                (setq newpt (trans newpt 1 0))
              )
              (setvar "orthomode" 0)
              (acet-ucs-cmd (list "_p"))
            ) ;progn
          ) if
        )
        ((not (null tmp))    ;;new ending point selected
          (setq start (acet-dxf 10 textent)
                newpt tmp)
        )
        (t  (setq start nil
                  newpt nil)
        )
      ) ;cond
      (if (and start newpt)
        (progn
          (setq val (assoc 41 textent) ;;current width factor
                val (if val (cdr val) 1.0)
                ltc_% (* (/ (distance start newpt) newend) val)
                textent (subst (cons 41 ltc_%)
                               (assoc 41 textent)
                               textent)
                textent (subst (cons 10 start)
                               (assoc 10 textent)
                               textent)
                textent (subst (cons 11 newpt)
                               (assoc 11 textent)
                               textent)
          ) ;setq
          (entmod textent)
          (entupd (acet-dxf -1 textent))
        )
      )  ;;end of points check
    )
  ) ;cond
  (acet-error-restore)
  (princ)
) ;end defun
 
 
 
 
(defun c:TFHELP (/)
 ;;;***ET2GP-Anpassung*** -> bersetzung Hilfetext
;;;(prompt " TEXTFIT will change the width factor of the selected text, \n")
;;;(prompt " to fit within the user specified points.\n")
;;;(prompt "\n")
;;;(prompt " TEXTFIT will prompt:  Select Text to stretch/shrink:\n")
;;;(prompt " The user is expected to select the text.\n")
;;;(prompt "\n")
;;;(prompt " TEXTFIT will then prompt:  Specify starting Point/<select new ending point>: \n")
;;;(prompt " At which time the user can specify a new ending point \n")
;;;(prompt "                          or\n")
;;;(prompt " The user can provide the letter \"S\" for a new starting point\n")
;;;(prompt " to which TEXTFIT will prompt:  Specify new starting point:  \n")
;;;(prompt " and:  ending point: \n")
;;; an die genderte Dialogfhrung angepasst von Peter Tropf:
(prompt " TEXTFIT kann den Breitenfaktor von gewhltem Text \n")
(prompt " auf die vom Benutzer eingegebenen Punkte ndern.\n")
(prompt "\n")
(prompt " TEXTFIT fragt: Whlen Sie einen Text zum Strecken oder Schrumpfen:\n")
(prompt " Der Benutzer wird aufgefordert, den Text zu whlen.\n")
(prompt "\n")
(prompt " TEXTFIT fragt dann: Endpunkt eingeben oder [Startpunkt]: \n")
(prompt " Der Benutzer kann direkt einen neuen Endpunkt eingeben\n")
(prompt "                         oder\n")
(prompt " nach Eintippen des Buchstabens \"S\" einen neuen Startpunkt eingeben.\n")
(prompt " Daraufhin fragt TEXTFIT:  Neuen Startpunkt eingeben: \n")
(prompt " und:  neuen Endpunkt eingeben: \n")
(textscr)
(princ)
)


(princ)
