/// *******************************************************************
/// *                                                                 *
/// * Wir sind das "Express-Tools 2 German Project"                   *
/// * Nachfolgend nur nach abgekrzt durch "ET2GP" !                  *
/// * --------------------------------------------------------------- *
/// * Die Beteiligten in alphabetischer Reihenfolge:                  *
/// *                                                                 *
/// * Vorname, Name      E-Mail-Adresse             Website           *
/// * --------------------------------------------------------------- *
/// * Holger Brischke       kontakt@defun.de        www.defun.de      *
/// * Martin Drese          drese@defun.de          keine Website     *
/// * Markus Hoffmann       hoffmann@defun.de       keine Website     *
/// * Marc Scherer          marc.scherer@zvo.com    keine Website     *
/// * Peter Tropf           info@petertropf.de      keine Website     *
/// *                                                                 *
/// * Special Guest (bersetzung der Hilfe-Texte)                     *
/// * Walter Verburg        walterverburg@web.de    keine Website     *
/// *******************************************************************
/// 
/// ***ET2GP-Anpassung*** ->Kommentar
/// Diese bersetzung der Express-Tools fr AutoCAD 2004 basiert auf den
/// originalen, mit AutoCAD 2004 gelieferten Express-Tools von Autodesk.
/// Da nicht jeder deutsch-sprachige User von AutoCAD des Englischen
/// mchtig ist, haben wir diese bersetzung vorgenommen.
/// 
/// nderungen an den Originaltexten sind immer mit einem einleitenden
/// Kommentar versehen, wobei die Steuerzeichen fr Kommentar je nach
/// Dateiart variiert:
///
/// Eine nderung an einer Lisp-Datei ist folgendermaen markiert:
/// 
/// ;;; ***ET2GP-Anpassung*** ..."
/// 
/// Bei einem DCL-File dann so:
///
/// "/// ***ET2GP-Anpassung*** ..." 
/// 
/// Originalzeilen bleiben soweit wie mglich erhalten, werden jedoch durch
/// ein "Auskommentieren" deaktiviert.
/// 
/// Anderweitige Modifikationen, wie z.B. komplett neue Zeilen oder permanent 
/// deaktivierte Funktionen sind mit einem erklrendem Kommentar versehen.
/// 
/// Beispiel:
/// ...
/// ;;; ***ET2GP-Anpassung*** -> Dialog bersetzt...
///          ;_ (prompt "\nSelect object(s) on the layer(s) to be isolated: ")
///          (prompt "\nObjekt(e) auf zu isolierenden Layern whlen: ")
/// ...
/// 
/// Jede angepasste Datei wird mit diesem Header vorneweg versehen wobei die
/// nachfolgenden Zeilen bezglich der Informationen (wie z.B. Name des bersetzers)
/// natrlich variabel sind.
/// 
/// ***ET2GP-Anpassung*** -> Kommentar
/// Version 1.0
/// 25.07.2003
/// Markus Hoffmann
//
//
//    YES_NO.DCL
//    Copyright  1999 by Autodesk, Inc.
//
//    Your use of this software is governed by the terms and conditions of the
//    License Agreement you accepted prior to installation of this software.
//    Please note that pursuant to the License Agreement for this software,
//    "[c]opying of this computer program or its documentation except as
//    permitted by this License is copyright infringement under the laws of
//    your country.  If you copy this computer program without permission of
//    Autodesk, you are violating the law."
//
//    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//    UNINTERRUPTED OR ERROR FREE.
//
//    Use, duplication, or disclosure by the U.S. Government is subject to
//    restrictions set forth in FAR 52.227-19 (Commercial Computer
//    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//    (Rights in Technical Data and Computer Software), as applicable.
//
//  ----------------------------------------------------------------

bns_yes_no60_15 : dialog {
  label = "";
  key = "title";
  width=60;
  height=15;

  : column {
    : text_part {
      label = "";
      key = "msg0";
    }
    : text_part {
      label = "";
      key = "msg1";
    }
    : text_part {
      label = "";
      key = "msg2";
    }
    : text_part {
      label = "";
      key = "msg3";
    }
    : text_part {
      label = "";
      key = "msg4";
    }
    : text_part {
      label = "";
      key = "msg5";
    }
    : text_part {
      label = "";
      key = "msg6";
    }
    : text_part {
      label = "";
      key = "msg7";
    }
  }
  : row {
    : spacer {}
    : spacer {}
    : spacer {}
    : button {
/// ***ET2GP-Anpassung*** Knopf-Label und Mnemonic-Key gendert
//    label = " Yes ";
//    mnemonic = "Y";
      label = " Ja ";
      mnemonic = "J";
      key = "accept";
      is_default=true;
      fixed_width=true;
      width=12;
    }
    : button {
/// ***ET2GP-Anpassung*** Knopf-Label gendert
//    label = " No  ";
      label = " Nein ";
      mnemonic = "N";
      key = "cancel";
      is_cancel=true;
      fixed_width=true;
      width=12;
    }
    : spacer {}
    : spacer {}
    : spacer {}
  }
}

bns_yes_no40_10 : dialog {
  label = "";
  key = "title";
  width=40;
  height=10;

  : column {
    : text_part {
      label = "";
      key = "msg0";
    }
    : text_part {
      label = "";
      key = "msg1";
    }
    : text_part {
      label = "";
      key = "msg2";
    }
    : text_part {
      label = "";
      key = "msg3";
    }
    : text_part {
      label = "";
      key = "msg4";
    }
    : text_part {
      label = "";
      key = "msg5";
    }
    : text_part {
      label = "";
      key = "msg6";
    }
    : text_part {
      label = "";
      key = "msg7";
    }
  }
  : row {
    : spacer {}
    : spacer {}
    : spacer {}
    : button {
/// ***ET2GP-Anpassung*** Knopf-Label und Mnemonic-Key gendert
//    label = " Yes ";
//    mnemonic = "Y";
      label = " Ja ";
      mnemonic = "J";
      key = "accept";
      is_default=true;
      fixed_width=true;
      width=12;
    }
    : button {
/// ***ET2GP-Anpassung*** Knopf-Label gendert
//    label = " No  ";
      label = " Nein ";
      mnemonic = "N";
      key = "cancel";
      is_cancel=true;
      fixed_width=true;
      width=12;
    }
    : spacer {}
    : spacer {}
    : spacer {}
  }
}

bns_yes_no20_5 : dialog {
  label = "";
  key = "title";
  width=20;
  height=5;

  : column {
    : text_part {
      label = "";
      key = "msg0";
    }
    : text_part {
      label = "";
      key = "msg1";
    }
    : text_part {
      label = "";
      key = "msg2";
    }
    : text_part {
      label = "";
      key = "msg3";
    }
    : text_part {
      label = "";
      key = "msg4";
    }
    : text_part {
      label = "";
      key = "msg5";
    }
  }
  : row {
    : spacer {}
    : button {
/// ***ET2GP-Anpassung*** Knopf-Label und Mnemonic-Key gendert
//    label = " Yes ";
//    mnemonic = "Y";
      label = " Ja ";
      mnemonic = "J";
      key = "accept";
      is_default=true;
      fixed_width=true;
      width=12;
    }
    : button {
/// ***ET2GP-Anpassung*** Knopf-Label gendert
//    label = " No  ";
      label = " Nein ";
      mnemonic = "N";
      key = "cancel";
      is_cancel=true;
      fixed_width=true;
      width=12;
    }
    : spacer {}
  }
}
